-- 藏宝柜
Lua_CollectionCabinetWindow = class("Lua_CollectionCabinetWindow.lua", Lua_Window);
function Lua_CollectionCabinetWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetWindow";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;

	self:preLoadWinBg();
end

function Lua_CollectionCabinetWindow:preLoadWinBg()
	local list = DataCenter.collectionCabinetUtil.collectionTabList;
	local arr = Lua_WindowUtil.getWinListData(self.windowName);
	local defaultIdx = 1;
	if arr and arr:getSize() > 0 then
		local defaultIdx = arr[1].main_id and arr[1].main_id or 1;
	end
	self.winBgPath = list[defaultIdx].winBg;
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionCabinetWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
	self.roleInfoPanel:setRectAnchor(1);
	self.roleInfoPanel:setAvatarClickOpenWin("Lua_TopLayerPersonalInfoWindow");

	self.btnListBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60.5, 720, 121);
	self.btnListBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.btnListBg.siblingIndex = 1;

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(8);
	self.btnList:setRectPivot(5);
	self.btnList:setLocation(0, 60.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 118, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 118, 0, 0, 1);
	self.btnList:setButtonItem(120, 108);
	self.btnList:setRedPoint(40, 40);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(DataCenter.collectionCabinetUtil.collectionTabList);
	self.btnList:setSelected(1);
end

function Lua_CollectionCabinetWindow:onScreenResize()
	self:superCall("onScreenResize");
end

function Lua_CollectionCabinetWindow:showWin(param)
	self:superCall("showWin", param);

	local toIndex = 1;
	if param.main_id then
		toIndex = param.main_id;
	end
	self.isSelect = param.sub_id ~= nil;
	self.btnList:setSelected(toIndex);
end

function Lua_CollectionCabinetWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1098, true);
end

function Lua_CollectionCabinetWindow:onBtnClick(index, data)
	if data then
		self.winBg.anchorValue = data.winBgAnchor;
		self.winBg.pivotValue = data.winBgPivot;
		self.winBg:setUrl(data.winBg);
		self.winBg:setLocation(data.winBgPosX, data.winBgPosY + GlobalVar.screenOffsetTopH);

		if self.showPanel ~= nil then
			self.showPanel:dispose();
			self.showPanel = nil;
		end
		local panel = checkRequire(data.panel);
		self.showPanel = panel.new(self.content);
		self.showPanel:setEnable(true);
		self.showPanel:setRectAnchor(9);
		self.showPanel:setSiblingIndex(data.siblingIndex);
		if self.isSelect and self.showPanel.setDefaultInfo then
			self.isSelect = false;
			self.showPanel:setDefaultInfo(self.showData);
		end
	else
		if self.showPanel ~= nil then
			self.showPanel:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetWindow:dispose()
	if self.btnListBg ~= nil then
		self.btnListBg:dispose();
		self.btnListBg = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.showPanel ~= nil then
		self.showPanel:dispose();
		self.showPanel = nil;
	end
	self:superCall("dispose");
end