-- 藏宝柜-图鉴界面
Lua_CollectionCabinetAtlasPanel = class("Lua_CollectionCabinetAtlasPanel", Lua_DisplayObject);
function Lua_CollectionCabinetAtlasPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetAtlasPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleIcon = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_2", "xui_cbg_title_4", -248, -144, 0, 0);
	self.titleIcon.anchorValue = 1;

	self.dragContainer = Lua_DragListContainer.new(self.content, 672, 1108 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer.tweenId = 2028;
	-- self.dragContainer.delayTween = true;
	self.dragContainer:setCellSpacing(0, 14);
	self.dragContainer:setLocation(0, -41, 0);

	local arr = DataCenter.collectionCabinetUtil.allColllectionColorIdsArr;
	local colorArr;
	for i = 1, arr:getSize() do
		colorArr = DataCenter.collectionCabinetUtil:getAllColllectColorIdsByColor(arr[i]);
		self.dragContainer:addChildData(arr[i], Lua_CollectionCabinetAtlasTitleItem, 672, 45, 1); -- 标题
		self.dragContainer:addChildData(colorArr, Lua_CollectionCabinetAtlasCollectionItem, 224, 259, 3); -- 内容
	end
	self.dragContainer:updateChildPos();
end

function Lua_CollectionCabinetAtlasPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);
		self.dragContainer:setContentRect(672, 1108 + adaptHeight);
	end
end

function Lua_CollectionCabinetAtlasPanel:dispose()
	if self.dragContainer then
		self.dragContainer:dispose()
		self.dragContainer = nil
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetAtlasTitleItem = class("Lua_CollectionCabinetAtlasTitleItem", Lua_DragContainerItem)
function Lua_CollectionCabinetAtlasTitleItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetAtlasTitleItem_skin");
end

function Lua_CollectionCabinetAtlasTitleItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CollectionCabinetAtlasTitleItem:setData(data)
	if data == nil then
		return;
	end

	self.titleBg:setAltas("collection_cabinet_atlas_2", "xui_cpg_quality_0"..data);
	self.qualityTxt.text = DataCenter.collectionCabinetUtil:getCollectionAtlasTitleNameByColor(data);

	local colorStr;
	if data == 3 then
		colorStr = "485A89";
	elseif data == 4 then
		colorStr = "654889";
	elseif data == 5 then
		colorStr = "98673D";
	else
		colorStr = "FFFFFF";
	end
	local activeArr = DataCenter.collectionCabinetData:getColllectColorIdsByColor(data);
	local totalArr = DataCenter.collectionCabinetUtil:getAllColllectColorIdsByColor(data);
	local activeNum = activeArr and activeArr:getSize() or 0;
	local totalNum = totalArr and totalArr:getSize() or 0;
	self.tipsTxt.text = LanUtil.formateStr(787027, activeNum, totalNum);
	self.tipsTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
end

function Lua_CollectionCabinetAtlasTitleItem:dispose()
	self:superCall("dispose");
end










Lua_CollectionCabinetAtlasCollectionItem = class("Lua_CollectionCabinetAtlasCollectionItem", Lua_DragContainerItem)
function Lua_CollectionCabinetAtlasCollectionItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetAtlasCollectionItem_skin");
end

function Lua_CollectionCabinetAtlasCollectionItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showStarArr = Array();

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setSiblingIndex(1);
	self.itemIcon:setLocation(0, 15, 0);
end

function Lua_CollectionCabinetAtlasCollectionItem:setData(data)
	self._data = DataCenter.collectionCabinetData:getCollectionCabinetVo(data);
	if data == nil or self._data == nil then
		return;
	end

	self.itemIcon:setData(self._data.tvo);
	self.itemIcon:setMask(not self._data.isActive);
	self.maxLvTxt.text = "+" .. self._data.maxLevel;
	self.nameTxt.text = self._data.tvo.name;
	self:showStar();
end

function Lua_CollectionCabinetAtlasCollectionItem:showStar()
	local actualStar = self._data.maxStar;
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local maxLen = showStar >= arrLen and showStar or arrLen;
	local width = 13;
	local startPosX = -(width * showStar) / 2 + width / 2;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.showStarArr[i];
		if showStar > 0 then
			if i > showStar then
				starIcon:setEnable(false);
			else
				if starIcon == nil then
					starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
					self.showStarArr:add(starIcon);
				end
				if 5 >= actualStar then
					starIcon:setAltas("common_altas_1", "xui_common_label_09");
				else
					starIcon:setAltas("common_altas_1", "xui_common_label_10");
				end
				starIcon:setLocation(startPosX + ((i - 1) % showStar) * width, -39, 0);
				starIcon:setEnable(true);
			end
		else
			starIcon:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetAtlasCollectionItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.itemBg.width / 2;
	local maxX = self.centerPosX + self.itemBg.width / 2;
	local minY = self.centerPosY - self.itemBg.height / 2;
	local maxY = self.centerPosY + self.itemBg.height / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_CollectionCabinetAtlasCollectionItem:onPressClick()
	if self._data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDetailWindow", Lua_WinParam.ACTION_OPEN, {data = self._data, showType = 4, isToggle = true});
end

function Lua_CollectionCabinetAtlasCollectionItem:dispose()
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.showStarArr then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end