-- 藏宝柜-碎片界面
Lua_CollectionCabinetChipPanel = class("Lua_CollectionCabinetChipPanel", Lua_DisplayObject);
function Lua_CollectionCabinetChipPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetChipPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleIcon = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_2", "xui_cbg_title_3", -248, -144, 0, 0);
	self.titleIcon.anchorValue = 1;

	self.subBtnBg = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_2", "xui_cpg_widget_18", 0, 112, 0, 0);
	self.subBtnBg.anchorValue = 7;
	self.subBtnBg.pivotValue = 7;

	self.itemList = Lua_DragList.new(self.content, 700, 996 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_CollectionCabinetChipItem, 175, 234, 4);
	self.itemList:setCellSpacing(0, 6);
	self.itemList:setLocation(0, 15, 0);

	local btnInfo = Array();
	btnInfo:add({textStr = 787023})
	btnInfo:add({textStr = 787024, redPointId = Lua_RedPointList.NewCollectionCabinet_Chip_CanActive})
	btnInfo:add({textStr = 787025, redPointId = Lua_RedPointList.NewCollectionCabinet_Chip_CanUpStar})
	btnInfo:add({textStr = 787026})

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonCell(Lua_CollectionCabinetChipBtnItem);
	self.btnList:setButtonItem(174, 56);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setRedPoint(73, 15);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, 168, 0);
	self.btnList:setData(btnInfo);
	self.btnList:setSelected(1);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_INFO", self, self.showCollectionChipInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCollectionChipInfo);
	self:addLuaEvent("MONEY_UPDATE", self, self.updateCollectionChipInfo);
end

function Lua_CollectionCabinetChipPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);
		self.itemList:setContentRect(700, 996 + adaptHeight);
	end
end

function Lua_CollectionCabinetChipPanel:setDefaultInfo(info)
	if info and info.sub_id and self.btnList then
		self.btnList:setSelected(info.sub_id);
	end
end

function Lua_CollectionCabinetChipPanel:updateCollectionChipInfo(dic)
	if self.recordChipIdArr and self.recordChipIdArr:getSize() > 0 then
		local isRefresh = false;
		for i = 1, self.recordChipIdArr:getSize() do
			if dic[self.recordChipIdArr[i]] then
				isRefresh = true;
				break;
			end
		end
		if not isRefresh then
			return;
		end
		self:showCollectionChipInfo();
	end
end

function Lua_CollectionCabinetChipPanel:onBtnClick(index, data)
	self.selectIdx = index;
	self:showCollectionChipInfo();
end

function Lua_CollectionCabinetChipPanel:showCollectionChipInfo()
	if self.recordChipIdArr == nil then
		self.recordChipIdArr = Array();
	end

	local arr = DataCenter.collectionCabinetUtil.allCollectionIdsArr;
	local tvo, collectVo;
	local showArr = Array();
	for i = 1, arr:getSize() do
		collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(arr[i]);
		if self.selectIdx == 1 then -- 碎片数量大于0
			tvo = DataCenter.packData:getItemVoById(collectVo.chipId);
			if (not collectVo.isActive and tvo and tvo.count > 0)
				or (collectVo.isActive and (not collectVo.isMaxStar or (collectVo.isMaxStar and tvo and tvo.count > 0))) then
				showArr:add(collectVo.chipId);
			end
		elseif self.selectIdx == 2 then -- 可激活
			if collectVo.isCanActive then
				showArr:add(collectVo.chipId);
			end
		elseif self.selectIdx == 3 then -- 可升星
			if collectVo.isCanUpStar then
				showArr:add(collectVo.chipId);
			end
		else -- 未激活
			if not collectVo.isActive then
				showArr:add(collectVo.chipId);
			end
		end
		if self.recordChipIdArr:indexOf(collectVo.chipId) == -1 then
			self.recordChipIdArr:add(collectVo.chipId);
		end
	end
	self.itemList:setArrayData(showArr);
	self.itemList:moveToIndex(1, true, false);
	self:showNone(showArr:getSize() <= 0);
end

function Lua_CollectionCabinetChipPanel:showNone(state)
	if state then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/common/xui_common_widget_029.png", -1, -714, 0, 0);
			self.noneIcon.anchorValue = 1;

			self.noneText = UICreate.createLabel(self.content, nil, 114, -675, 100, 36, 36);
			self.noneText.anchorValue = 1;
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("E3D7DA");
			self.noneText:setLangValue(787000);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetChipPanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.recordChipIdArr ~= nil then
		self.recordChipIdArr:dispose();
		self.recordChipIdArr:clear();
		self.recordChipIdArr = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetChipBtnItem = class("Lua_CollectionCabinetChipBtnItem", Lua_ButtonCell);
function Lua_CollectionCabinetChipBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetChipBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_2", "xui_ys_tab_01", 0, 0, 171, 56);
	self.btnBg.clickScale = false;
	self.btnBg:addClickFuntion(self, self.onPressClick)

	self.btnTxt = UICreate.createLabel(self.content, nil, 0, 0, 100, 40, 30);
	self.btnTxt.pivotValue = 4;
	self.btnTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.btnTxt.alignmentValue = 4;
	self.btnTxt.horizontalOverflowValue = 1;
end

function Lua_CollectionCabinetChipBtnItem:setData(data)
	self:superCall("setData", data);
	if type(data) == type_str_number then
		self.btnTxt:setLangValue(data);
	elseif type(data.textStr) == type_str_number then
		self.btnTxt:setLangValue(data.textStr);
	else
		self.btnTxt.text = data.textStr;
	end
end

function Lua_CollectionCabinetChipBtnItem:setCanClick(bCan)
	if bCan then
		self.btnBg.mouseEnable = true;
		self.btnBg:addClickFuntion(self, self.onPressClick);
	else
		self.btnBg.mouseEnable = false;
		self.btnBg:removeClickFuntion(self, self.onPressClick);
	end
end

function Lua_CollectionCabinetChipBtnItem:setSelected(index)
	self:superCall("setSelected", index)
	if index == self.index then
		self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_ys_tab_02");
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("89583A");
	else
		self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_ys_tab_01");
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("8A7564");
	end
end

function Lua_CollectionCabinetChipBtnItem:dispose()
	if self.btnBg ~= nil then
		self.btnBg:dispose();
		self.btnBg = nil;
	end
	if self.btnTxt ~= nil then
		self.btnTxt:dispose();
		self.btnTxt = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetChipItem = class("Lua_CollectionCabinetChipItem", Lua_ListCell);
function Lua_CollectionCabinetChipItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetChipItem_skin");
end

function Lua_CollectionCabinetChipItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(1)
	self.itemIcon:setLocation(-2, 31, 0);
end

function Lua_CollectionCabinetChipItem:setData(data)
	if data == nil then
		return;
	end

	self._data = DataCenter.packData:getItemVoById(data) or Lua_ToolVo.createToolVo(data);
	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(self._data.collectionCabinetId);
	self.itemIcon:setData(self._data);
	self.itemIcon:showNum(0);
	self.itemIcon:setDoubleIcon(nil);
	self.itemIcon:showRedPoint(collectVo.chipRedpoint); -- self._data.canSynthesis);

	self.nameTxt.text = self._data.name;

	local maxValue = DataCenter.collectionCabinetData:getCurChipNumByCollectId(self._data.collectionCabinetId); -- self._data.chipLimitNum;
	local value = DataCenter.packData:getItemCountById(data)
	self.progressBar:setMaxValue(maxValue);
	self.progressBar:setValue(value);
	if maxValue > 0 then
		self.progressBar:setText(value .."/".. maxValue);
	else
		self.progressBar:setText(value);
	end
end

-- 判断是否范围内
function Lua_CollectionCabinetChipItem:checkInBound(posX, posY)
	self.minX = self.centerPosX + self.itemIcon.x - self.itemIcon.w / 2;
	self.maxX = self.centerPosX + self.itemIcon.x + self.itemIcon.w / 2;
	self.minY = self.centerPosY + self.itemIcon.y - self.itemIcon.h / 2;
	self.maxY = self.centerPosY + self.itemIcon.y + self.itemIcon.h / 2;
	return posX >= self.minX and posX <= self.maxX and posY >= self.minY and posY <= self.maxY;
end

function Lua_CollectionCabinetChipItem:onPressClick()
	if self._data == nil or self._data.id == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self._data, true, true);
end

function Lua_CollectionCabinetChipItem:onMouseDownHandle()
	self.itemIcon:setScale(0.95, 0.95, 0.95);
end

function Lua_CollectionCabinetChipItem:onMouseUpHandle()
	self.itemIcon:setScale(1, 1, 1);
end

function Lua_CollectionCabinetChipItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end