-- 藏宝柜-激活成功界面
Lua_CollectionCabinetActiveSucceedWindow = class("Lua_CollectionCabinetActiveSucceedWindow", Lua_Window);
function Lua_CollectionCabinetActiveSucceedWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetActiveSucceedWindow";
	self.skinName = "CollectionCabinetActiveSucceedWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -479;

	self:addPreLoadRes("/images/common/xui_common_bg_002.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/common/xui_common_window_010.png", Lua_LoadFileType.IMG);
end

function Lua_CollectionCabinetActiveSucceedWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 270, 0);

	self.infoBg:addClickFuntion(self, self.onBtnCloseClick);
end

function Lua_CollectionCabinetActiveSucceedWindow:showWin(param)
	self:superCall("showWin", param);

	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(param);
	OperateAlert.show(LanUtil.formateStr(787004, collectVo.name));

	self.itemIcon:setData(collectVo.tvo);

	local attrArr = self:getPropInfo(collectVo.starNormalProp, collectVo.lvNormalProp);
	self.showItemArr = Array();
	for i = 1, attrArr:getSize() do
		item = Lua_CollectionCabinetActiveTipsItem.new(self.content);
		item.contentName = "Lua_CollectionCabinetActiveTipsItem_" .. i;
		item:setLocation(0, 67 - 46 * (i - 1));
		item:setData(attrArr[i], i);
		self.showItemArr:add(item);
	end

	local starEntryConfig = collectVo.starEntryConfig;
	local attrVo;
	local desStr = "";
	if starEntryConfig then
		if starEntryConfig.show_entry_type == 1 then
			desStr = starEntryConfig.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";
			local attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
		elseif starEntryConfig.show_entry_type == 2 then
			desStr = starEntryConfig.other_desc
		elseif starEntryConfig.show_entry_type == 3 then
			desStr = starEntryConfig.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";
			local attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
			desStr = desStr .. "，" .. starEntryConfig.other_desc
		end
	end
	self.starDesTxt.text = desStr;
end

function Lua_CollectionCabinetActiveSucceedWindow:getPropInfo(starProp, lvProp)
	local attrDic = DataCenter.attributesUtil:getAttrDic(starProp);
	attrDic = DataCenter.attributesUtil:getAttrDic(lvProp, attrDic);
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	return attrArr;
end

function Lua_CollectionCabinetActiveSucceedWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	DataCenter.collectionCabinetData:showActiveCollection();
	self:superCall("dispose");
end










Lua_CollectionCabinetActiveTipsItem = class("Lua_CollectionCabinetActiveTipsItem", Lua_DisplayObject);
function Lua_CollectionCabinetActiveTipsItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetActiveTipsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_window_010_3", 0, -3, 720, 39);

	self.attrTxt = UICreate.createLabel(self.content, "", -136, 0, 100, 31, 26);
	self.attrTxt.verticalOverflowValue = 1;
	self.attrTxt.alignmentValue = 3;
	self.attrTxt.fontName = Lua_MyUISettings.huakangFontName;

	self.valueTxt = UICreate.createLabel(self.content, "", 103, 0, 100, 31, 26);
	self.valueTxt.verticalOverflowValue = 1;
	self.valueTxt.alignmentValue = 5;
	self.valueTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.valueTxt.colorStr = Lua_ColorDefine.transColorStr("F7EDCC");
end

function Lua_CollectionCabinetActiveTipsItem:setData(data, idx)
	self.itemBg:setEnable(idx % 2 == 0);
	self.attrTxt.text = data.show_name;
	self.valueTxt.text = data.showValue;
end

function Lua_CollectionCabinetActiveTipsItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.attrTxt ~= nil then
		self.attrTxt:dispose();
		self.attrTxt = nil;
	end
	if self.valueTxt ~= nil then
		self.valueTxt:dispose();
		self.valueTxt = nil;
	end
	self:superCall("dispose");
end