-- 藏品柜详情信息
Lua_CollectionCabinetDetailWindow = class("Lua_CollectionCabinetDetailWindow", Lua_Window);
function Lua_CollectionCabinetDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetDetailWindow";
	self.skinName = "CollectionCabinetDetailWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_CollectionCabinetDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showItemArr = Array();
	self.showStarArr = Array();

	self.scoreNum = Lua_NumberImage.new(self.showObj);
	self.scoreNum.pivot = 1;
	self.scoreNum.numOffsetX = -2;
	self.scoreNum.numAtlas = "number";
	self.scoreNum.preStr = "xui_zl1_number_0";
	self.scoreNum.scaleVal = 0.8;
	self.scoreNum:setLocation(-67, -87, 0);

	self.shareBtn:addClickFuntion(self, self.onShareClick);
	self.leftBtn:addClickFuntion(self, self.onLeftClick);
	self.rightBtn:addClickFuntion(self, self.onRightClick);
	self.starDesTxt:addUrlClickFuntion(self, self.onUrlClickFun);
	self.lvPreviewBtn:addClickFuntion(self, self.onLvPreviewClick);
	self.starPreviewBtn:addClickFuntion(self, self.onStarPreviewClick);
	self.upLvBtn:addClickFuntion(self, self.onUpLvClick);
	self.upStarBtn:addClickFuntion(self, self.onUpStarClick);
end

function Lua_CollectionCabinetDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local isShowBtn = false;
	local collectVo;
	local arr = DataCenter.collectionCabinetUtil.allCollectionIdsArr;
	if param.showType == 1 then -- 查看自己的藏品
		isShowBtn = true;
		collectVo = param.data;
		arr = DataCenter.collectionCabinetData.collectionActiveArr;
	elseif param.showType == 2 then -- 道具tips
		collectVo = Lua_ToolVo.createToolVo(param.id);
	elseif param.showType == 3 then -- 聊天场景
		collectVo = Lua_ToolVo.createToolVo(param.data.collection_item_id);
		collectVo:fromServer(param.data);
	elseif param.showType == 4 then -- 图鉴
		collectVo = param.data;
	end
	self.shareBtn:setEnable(isShowBtn);
	self.upLvBtn:setEnable(isShowBtn);
	self.upStarBtn:setEnable(isShowBtn);

	self.startIdx = 1;
	self.maxIdx = arr:getSize();
	for i = 1, self.maxIdx do
		if collectVo.id == arr[i] then
			self.moveIdx = i;
			break;
		end
	end
	self.leftBtn:setEnable(param.isToggle);
	self.rightBtn:setEnable(param.isToggle);

	self:showDetailInfo(collectVo);
end

function Lua_CollectionCabinetDetailWindow:showDetailInfo(collectVo)
	self.collectVo = collectVo;

	self.winBg:setAltas("common_altas_2", "xui_common_itembg_"..(collectVo.color + 6));
	self.itemIcon:setAltas(collectVo.atlas, collectVo.sprite);
	self.nameTxt.text = collectVo.name;

	if self.showData.showType == 1 or self.showData.showType == 3 then
		self.timeDesTxt:setLangValue(787005);
		self.timeTxt.text = os.date("%Y/%m/%d", collectVo.getTick);
	else
		self.timeDesTxt:setLangValue(787006);
		self.timeTxt.text = collectVo.tvo.effect_des;
	end

	local showScore = collectVo.showScore;
	local attrArr = self:getPropInfo(collectVo.starNormalProp, collectVo.lvNormalProp, collectVo.prop);
	local levelDes = collectVo.levelDes;
	local starEntryConfig = collectVo.starEntryConfig;
	local showStar = collectVo.starLv;
	local showLv = collectVo.level;
	local starId, starConfig, levelId, lvConfig;
	if self.showData.showType == 4 then
		starId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(collectVo.id, collectVo.maxStar);
		starConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(starId);
		showStar = collectVo.maxStar;
		starEntryConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetEntryConfig(starConfig.special_nature_id);

		levelId = DataCenter.collectionCabinetUtil:getCollectionCabinetLvId(collectVo.levelNormalType, collectVo.maxLevel);
		lvConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetLvConfig(levelId);
		showLv = collectVo.maxLevel;
		levelDes = lvConfig.level_des;
		showScore = collectVo.score + starConfig.score + lvConfig.score;
		attrArr = self:getPropInfo(starConfig.normal_prop, lvConfig.normal_prop, starEntryConfig.prop);
	end
	self.scoreNum.num = showScore;

	local posList = {{-236, -168.5}, {3, -168.5}, {-236, -208.5}, {3, -208.5}};
	local item;
	if attrArr ~= nil then
		for i = 1, attrArr:getSize() do
			item = self.showItemArr[i];
			if item == nil then
				item = Lua_CollectionCabinetAttrItem.new(self.showObj);
				item.contentName = "Lua_CollectionCabinetAttrItem_" .. i;
				item:setLocation(posList[i][1], posList[i][2]);
				self.showItemArr:add(item);
			end
			item:setData(attrArr[i]);
		end
	end

	starId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(collectVo.id, collectVo.initialStar);
	starConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(starId);
	local colorStr = collectVo.level < starConfig.max_level and self.showData.showType ~= 4 and "7F7F7F" or "52B16B";
	self.levelTxt.text = LanUtil.formateStr(787007, showLv);
	self.lvDesTxt.text = levelDes;
	self.lvDesTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.tipsTxt.text = collectVo.tvo.des;
	self.levelBg:setEnable(showLv > 0);
	self.levelTxt:setEnable(showLv > 0);

	local info, targetValue, curProgress, attrArr;
	local desStr = "";
	local progressStr = "";
	if starEntryConfig then
		if starEntryConfig.show_entry_type == 1 then
			if self.showData.showType == 1 or self.showData.showType == 4 then
				desStr = starEntryConfig.func_path_desc .. "，";
			else
				desStr = starEntryConfig.title_desc .. "，";
			end
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";

			info = getConfig("total_task", starEntryConfig.grow_cond_id);
			targetValue = info.client_condition and getConfig(info.client_condition[1], info.progress, info.client_condition[2]) or info.progress;
			targetValue = Mathf.Floor(targetValue / starEntryConfig.each);
			curProgress = self.showData.showType == 4 and targetValue or collectVo.growProgress; -- Mathf.Floor(collectVo.growProgress / starEntryConfig.each);
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				attrArr[i].value = attrArr[i].value * curProgress;
				progressStr = progressStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
					progressStr = progressStr .. "，";
				end
			end
			desStr = desStr .. LanUtil.formateStr(787008, curProgress, targetValue, progressStr);
		elseif starEntryConfig.show_entry_type == 2 then
			desStr = starEntryConfig.other_desc;
		elseif starEntryConfig.show_entry_type == 3 then
			if self.showData.showType == 1 or self.showData.showType == 4 then
				desStr = starEntryConfig.func_path_desc .. "，";
			else
				desStr = starEntryConfig.title_desc .. "，";
			end
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";

			info = getConfig("total_task", starEntryConfig.grow_cond_id);
			targetValue = info.client_condition and getConfig(info.client_condition[1], info.progress, info.client_condition[2]) or info.progress;
			targetValue = Mathf.Floor(targetValue / starEntryConfig.each);
			curProgress = self.showData.showType == 4 and targetValue or collectVo.growProgress; -- Mathf.Floor(collectVo.growProgress / starEntryConfig.each);
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				attrArr[i].value = attrArr[i].value * curProgress;
				progressStr = progressStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
					progressStr = progressStr .. "，";
				end
			end
			desStr = desStr .. LanUtil.formateStr(787008, curProgress, targetValue, progressStr) .. "\n" .. starEntryConfig.other_desc;
		end
	end
	self.starDesTxt.text = desStr;

	self.lvDesTxt:resetSize();
	self.starDesTxt:resetSize();
	self.tipsTxt:resetSize();
	self.lvBg:setLocation(-269, posList[self.showItemArr:getSize()][2] - 64.5, 0);
	self.lvTxt:setLocation(-249, self.lvBg.posY + 1, 0);
	self.lvDesTxt:setLocation(-249, self.lvTxt.posY - 27, 0);
	self.starBg:setLocation(-269, self.lvDesTxt.posY - self.lvDesTxt.height - 32, 0);
	self.starTxt:setLocation(-249, self.starBg.posY + 1, 0);
	self.starDesTxt:setLocation(-249, self.starTxt.posY - 27, 0);
	self.line_1:setLocation(0, self.starDesTxt.posY - self.starDesTxt.height - 26, 0);
	self.lvPreviewBtn:setLocation(202, self.lvBg.posY + 1, 0);
	self.lvPreviewTxt:setLocation(202, self.lvPreviewBtn.posY, 0);
	self.starPreviewBtn:setLocation(202, self.starBg.posY + 1, 0);
	self.starPreviewTxt:setLocation(202, self.starPreviewBtn.posY, 0);
	self.tipsTxt:setLocation(-248, self.line_1.posY - 15, 0);
	self.upLvBtn:setLocation(-129, self.tipsTxt.posY - self.tipsTxt.height - 43, 0);
	self.upStarBtn:setLocation(129, self.tipsTxt.posY - self.tipsTxt.height - 43, 0);

	local height;
	if self.showData.showType == 1 then
		height = -self.upStarBtn.posY + 45;
	else
		height = -self.tipsTxt.posY + self.tipsTxt.height + 30;
	end
	self.winBg:SetDimensions(544, height);
	LuaUtil.setObjPos(self.showObj, 0, self.winBg.height / 2, 0);

	self:showStarFun(showStar);
	self:showUpLvRed(self.showData.showType == 1 and collectVo.isCanUpLv);
	self:showUpStarRed(self.showData.showType == 1 and collectVo.isCanUpStar);
end

function Lua_CollectionCabinetDetailWindow:getPropInfo(starProp, lvProp, entryProp)
	local attrDic = DataCenter.attributesUtil:getAttrDic(starProp);
	attrDic = DataCenter.attributesUtil:getAttrDic(lvProp, attrDic);
	-- attrDic = DataCenter.attributesUtil:getAttrDic(entryProp, attrDic);
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	return attrArr;
end

function Lua_CollectionCabinetDetailWindow:showStarFun(actualStar)
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local maxLen = showStar > arrLen and showStar or arrLen;
	local width = 13;
	local startPosX = -195 - (width * showStar) / 2 + width / 2;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.showStarArr[i];
		if i > showStar then
			if starIcon then
				starIcon:setEnable(false);
			end
		else
			if starIcon == nil then
				starIcon = UICreate.createUIAtlasImage(self.showObj, nil, nil, 0, 0, 0, 0);
				self.showStarArr:add(starIcon);
			end
			starIcon:setEnable(true);
			starIcon:setLocation(startPosX + ((i - 1) % showStar) * width, -94, 0);
			if 5 >= actualStar then
				starIcon:setAltas("common_altas_1", "xui_common_label_09");
			else
				starIcon:setAltas("common_altas_1", "xui_common_label_10");
			end
		end
	end
end

function Lua_CollectionCabinetDetailWindow:showUpLvRed(bShow)
	if bShow == true then
		if self.upLvRedPoint == nil then
			self.upLvRedPoint = Lua_RedPointIcon.new(self.showObj);
			self.upLvRedPoint:createRedPointEff();
		end
		self.upLvRedPoint:setLocation(self.upLvBtn.posX + 60, self.upLvBtn.posY + 19, 0);
		self.upLvRedPoint:updateRedPointShow(true);
	else
		if self.upLvRedPoint ~= nil then
			self.upLvRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionCabinetDetailWindow:showUpStarRed(bShow)
	if bShow == true then
		if self.upStarRedPoint == nil then
			self.upStarRedPoint = Lua_RedPointIcon.new(self.showObj);
			self.upStarRedPoint:createRedPointEff();
		end
		self.upStarRedPoint:setLocation(self.upStarBtn.posX + 60, self.upStarBtn.posY + 19, 3, 0);
		self.upStarRedPoint:updateRedPointShow(true);
	else
		if self.upStarRedPoint ~= nil then
			self.upStarRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionCabinetDetailWindow:onShareClick(go)
	local param = {data = self.collectVo, posX = self.shareBtn.posX, posY = self.showObj.transform.localPosition.y + self.shareBtn.posY};
	Lua_WindowUtil.openWin("Lua_CollectionCabinetShareWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_CollectionCabinetDetailWindow:onLeftClick(go)
	if self.moveIdx - 1 < self.startIdx then
		self.moveIdx = self.maxIdx + 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx - 1;
	self:onToggleFun();
end

function Lua_CollectionCabinetDetailWindow:onRightClick(go)
	if self.moveIdx + 1 > self.maxIdx then
		self.moveIdx = self.startIdx - 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx + 1;
	self:onToggleFun();
end

function Lua_CollectionCabinetDetailWindow:onToggleFun()
	-- self.leftBtn:setEnable(self.moveIdx > self.startIdx and self.showData.isToggle);
	-- self.rightBtn:setEnable(self.moveIdx < self.maxIdx and self.showData.isToggle);
	local arr = DataCenter.collectionCabinetUtil.allCollectionIdsArr;
	if self.showData.showType == 1 then -- 查看自己的藏品
		arr = DataCenter.collectionCabinetData.collectionActiveArr;
	end
	local collectId = arr[self.moveIdx];
	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(collectId);
	self:showDetailInfo(collectVo);
end

function Lua_CollectionCabinetDetailWindow:onUrlClickFun(urlStr)
	if self.showData.showType == 1 or self.showData.showType == 4 then
		local arr = string.split(urlStr, "_");
		if arr and arr:getSize() > 2 then
			if not DataCenter.funcOpenData:isOpened(tonumber(arr[2]), true) then
				return;
			end
			DataCenter.funcPathUtil:gotoFunction(tonumber(arr[3]), true);
		end
	end
end

function Lua_CollectionCabinetDetailWindow:onLvPreviewClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetUpDesWindow", Lua_WinParam.ACTION_OPEN, {data = self.collectVo, upType = 2});
end

function Lua_CollectionCabinetDetailWindow:onStarPreviewClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetUpDesWindow", Lua_WinParam.ACTION_OPEN, {data = self.collectVo, upType = 1});
end

function Lua_CollectionCabinetDetailWindow:onUpLvClick(go)
	local isToggle = DataCenter.collectionCabinetData.collectionActiveArr:getSize() > 1;
	Lua_WindowUtil.openWin("Lua_CollectionCabinetUpLvWindow", Lua_WinParam.ACTION_OPEN, {data = self.collectVo, isToggle = isToggle});
	self:hide();
end

function Lua_CollectionCabinetDetailWindow:onUpStarClick(go)
	local isToggle = DataCenter.collectionCabinetData.collectionActiveArr:getSize() > 1;
	Lua_WindowUtil.openWin("Lua_CollectionCabinetUpStarWindow", Lua_WinParam.ACTION_OPEN, {data = self.collectVo, isToggle = isToggle});
	self:hide();
end

function Lua_CollectionCabinetDetailWindow:dispose()
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	if self.showStarArr ~= nil then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	if self.upLvRedPoint ~= nil then
		self.upLvRedPoint:dispose();
		self.upLvRedPoint = nil;
	end
	if self.upStarRedPoint ~= nil then
		self.upStarRedPoint:dispose();
		self.upStarRedPoint = nil;
	end
	self.collectVo = nil;
	self:superCall("dispose");
end










-- 带Icon的属性描述
Lua_CollectionCabinetAttrItem = class("Lua_CollectionCabinetAttrItem", Lua_DisplayObject);
function Lua_CollectionCabinetAttrItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetAttrItem_skin");
end

function Lua_CollectionCabinetAttrItem:setData(data)
	if data == nil then
		return;
	end
	self.attrIcon:setAltas("common_altas_2", data.attr_icon_2);
	self.attrTxt.text = LanUtil.formateStr(787050, data.show_name, data.showValue);
end