-- 藏品柜-战力总览界面
Lua_CollectionCabinetForceReadWindow = class("Lua_CollectionCabinetForceReadWindow", Lua_Window);
function Lua_CollectionCabinetForceReadWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetForceReadWindow";
	self.skinName = "CollectionCabinetForceReadWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	-- self.blackAlpha = 0.01;
end

function Lua_CollectionCabinetForceReadWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	local totalStar, totalLv = 0, 0;
	local specialAttrDic;
	local attrDic = {};
	local otherAttrDic = {};
	for i = 1, arr:getSize() do
		collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(arr[i]);
		totalStar = totalStar + collectVo.starLv;
		totalLv = totalLv + collectVo.level;

		specialAttrDic = {};
		if collectVo.show_entry_type == 1 or collectVo.show_entry_type == 3 then
			for k,v in pairs(collectVo.prop) do
				specialAttrDic[k] = v * collectVo.growProgress;
			end
		end
		attrDic = self:getPropDic(collectVo.starNormalProp, collectVo.lvNormalProp, specialAttrDic, attrDic);

		if collectVo.other_prop then
			otherAttrDic = DataCenter.attributesUtil:getAttrDic(collectVo.other_prop, otherAttrDic);
		end
	end
	self.numTxt.text = arr:getSize();
	self.totalLvTxt.text = totalLv;
	self.totalStarLvTxt.text = totalStar;

	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	local baseStartPosY = 55;
	local item;
	self.showItemArr = Array();
	for i = 1, attrArr:getSize() do
		posX = i % 2 ~= 0 and -145 or 145;
		posY = baseStartPosY - Mathf.Ceil(i / 2) * 59;
		item = Lua_CollectionCabinetForceReadItem.new(self.content);
		item:setLocation(posX, posY);
		item:setData(attrArr[i]);
		self.showItemArr:add(item);
	end

	local otherAttrArr = DataCenter.attributesUtil:getAttrArrByDic(otherAttrDic);
	local posY = baseStartPosY - Mathf.Ceil(self.showItemArr:getSize() / 2) * 59 - 87;
	self.titleBg_2:setLocation(0, posY, 0);
	self.titleTxt_2:setLocation(0, posY, 0);
	self.titleBg_2:setEnable(otherAttrArr:getSize() > 0);
	self.titleTxt_2:setEnable(otherAttrArr:getSize() > 0);

	local specialStartPosY = posY - 69;
	local item, posX;
	for i = 1, otherAttrArr:getSize() do
		posX = i % 2 ~= 0 and -145 or 145;
		posY = specialStartPosY - (Mathf.Ceil(i / 2) - 1) * 59;
		item = Lua_CollectionCabinetForceReadItem.new(self.content);
		item:setLocation(posX, posY);
		item:setData(otherAttrArr[i]);
		self.showItemArr:add(item);
	end

	local height;
	if otherAttrArr:getSize() > 0 then
		height = self.winBg.posY - posY + 89;
	else
		height = self.winBg.posY - (baseStartPosY - Mathf.Ceil(attrArr:getSize() / 2) * 59) + 89;
	end
	self.winBg:SetDimensions(684, height);
end

function Lua_CollectionCabinetForceReadWindow:getPropDic(starProp, lvProp, growUpProp, attrDic)
	attrDic = DataCenter.attributesUtil:getAttrDic(starProp, attrDic);
	attrDic = DataCenter.attributesUtil:getAttrDic(lvProp, attrDic);
	attrDic = DataCenter.attributesUtil:getAttrDic(growUpProp, attrDic);
	return attrDic;
end

function Lua_CollectionCabinetForceReadWindow:dispose()
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetForceReadItem = class("Lua_CollectionCabinetForceReadItem", Lua_DisplayObject);
function Lua_CollectionCabinetForceReadItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetForceReadItem_skin");
end

function Lua_CollectionCabinetForceReadItem:setData(data)
	if data == nil then
		return;
	end
	self.attrIcon:setAltas("common_altas_2", data.attr_icon_2);
	self.attrTxt.text = data.show_name .. "："
	self.attrValTxt.text = data.showValue;
end