-- 藏品柜-成长进度弹窗
Lua_CollectionCabinetGrowUpWindow = class("Lua_CollectionCabinetGrowUpWindow", Lua_Window);
function Lua_CollectionCabinetGrowUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetGrowUpWindow";
	self.skinName = "CollectionCabinetGrowUpWindow_skin";
    self.isFullSizeWin = true;
end

function Lua_CollectionCabinetGrowUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg:addClickFuntion(self, self.onJumpClick);
end

function Lua_CollectionCabinetGrowUpWindow:showWin(param)
	self:superCall("showWin", param);

	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(param);
	self.itemIcon:setAltas(collectVo.atlas, collectVo.sprite);
	self.nameTxt.text = collectVo.name;
	self.completeTxt.text = LanUtil.formateStr(collectVo.popup_desc, collectVo.changeProgress * collectVo.each);

	local vo
	local curAttrStr = "";
	local attrDic = {};
	for k,v in pairs(collectVo.prop) do
		attrDic[k] = v * collectVo.changeProgress;
	end
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	for i = 1, attrArr:getSize() do
		curAttrStr = curAttrStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
		if i ~= attrArr:getSize() then
			curAttrStr = curAttrStr .. Lua_SpaceDefine.SPACE_TIME;
		end
	end
	self.upTxt.text = curAttrStr;

	local info = getConfig("total_task", collectVo.grow_cond_id);
	local targetValue = info.client_condition == nil and info.progress or getConfig(info.client_condition[1], info.progress, info.client_condition[2]);
	targetValue = Mathf.Floor(targetValue / collectVo.each);
	local curValue = collectVo.growProgress; -- Mathf.Floor(collectVo.growProgress / collectVo.each);
	self.progressBar:setMaxValue(targetValue);
	self.progressBar:setValue(curValue);
	self.progressBar:setText(curValue .. "/" .. targetValue);

	self.time = 2;
	Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);
	self:onCountDown();
end

function Lua_CollectionCabinetGrowUpWindow:onCountDown()
	self.time = self.time - 1;
	if self.time < 0 then
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
		Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
		DataCenter.collectionCabinetData:showGrowUpCollection();
	end
end

function Lua_CollectionCabinetGrowUpWindow:onJumpClick(go)
	if not Lua_WindowUtil.isWindowShowing("Lua_CollectionCabinetWindow") then
		Lua_WindowUtil.openWin("Lua_CollectionCabinetWindow");
	end
	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(self.showData);
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDetailWindow", Lua_WinParam.ACTION_OPEN, {data = collectVo, showType = 1, isToggle = false});
	Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
	DataCenter.collectionCabinetData:showGrowUpCollection();
end

function Lua_CollectionCabinetGrowUpWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	self:superCall("dispose");
end