-- 藏宝柜-主界面
Lua_CollectionCabinetMainPanel = class("Lua_CollectionCabinetMainPanel", Lua_DisplayObject);
function Lua_CollectionCabinetMainPanel:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetMainPanel_skin");
end

function Lua_CollectionCabinetMainPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showBg:SetDimensions(720, 1020 + self.adaptHeight);

	self.warOrderRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.WarOrder_CollectionCabinet);
	self.warOrderRedPoint:setRectAnchor(1);
	self.warOrderRedPoint:setLocation(310, -185, 0);

	self.forceNum = Lua_NumberImage.new(self.content);
	self.forceNum.pivot = 1;
	self.forceNum.numOffsetX = -2;
	self.forceNum.numAtlas = "number";
	self.forceNum.preStr = "xui_zl1_number_0";
	self.forceNum.scaleVal = 0.8;
	self.forceNum:setRectAnchor(1);
	self.forceNum:setLocation(155, -316, 0);

	self.collectList = Lua_DragList.new(self.content, 699, 924 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.collectList.contentName = "collectList";
	self.collectList.tweenId = 2015;
	self.collectList:setListCell(Lua_CollectionCabinetItem, 699, 201, 1);
	self.collectList:setLocation(0, -108);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.warIcon:addClickFuntion(self, self.onGotoClick);
	self.forceReadBtn:addClickFuntion(self, self.onForceReadClick);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_INFO", self, self.updateCollectionInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCollectionInfo);
	self:addLuaEvent("MONEY_UPDATE", self, self.updateCollectionInfo);
	self:updateCollectionInfo();
end

function Lua_CollectionCabinetMainPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);

		self.showBg:SetDimensions(720, 1020 + adaptHeight);
		self.collectList:setContentRect(699, 924 + adaptHeight);
	end
end

function Lua_CollectionCabinetMainPanel:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1098, true);
end

function Lua_CollectionCabinetMainPanel:updateCollectionInfo()
	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	local totalForce, index, num = 0, 0, 0;
	local collectVo, color;
	local showList = {};
	for i = 1, arr:getSize() do
		collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(arr[i]);
		totalForce = totalForce + collectVo.collectForce;
		if color ~= collectVo.color or num >= 3 then
			color = collectVo.color;
			index = index + 1;
			num = 0;
		end
		num = num + 1;

		if showList[index] == nil then
			showList[index] = Array();
		end
		showList[index]:add(arr[i]);
	end
	self.collectList:setArrayData(showList);
	self.collectList:setEnable(arr:getSize() > 0);
	self:showNone(arr:getSize() <= 0);

	self.forceNum.num = totalForce;
	-- self.forceIcon:setLocation(self.forceNum.posX - self.forceNum.totalWidth - 30, self.forceNum.posY, 0);
end

function Lua_CollectionCabinetMainPanel:showNone(state)
	if state then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/common/xui_common_widget_029.png", -1, -714, 0, 0);
			self.noneIcon.anchorValue = 1;

			self.noneText = UICreate.createLabel(self.content, nil, 114, -675, 100, 36, 36);
			self.noneText.anchorValue = 1;
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("E3D7DA");
			self.noneText:setLangValue(787000);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetMainPanel:onRuleClick(go)
	local tipData = { des = 787002, posX = 180, posY = -248 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_CollectionCabinetMainPanel:onGotoClick(go)
	DataCenter.funcPathUtil:gotoFunction(1185);
end

function Lua_CollectionCabinetMainPanel:onForceReadClick(go)
	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	if arr:getSize() <= 0 then
		OperateAlert.showLangValue(787001);
	else
		Lua_WindowUtil.openWin("Lua_CollectionCabinetForceReadWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_CollectionCabinetMainPanel:dispose()
	if self.warOrderRedPoint ~= nil then
		self.warOrderRedPoint:dispose();
		self.warOrderRedPoint = nil;
	end
	if self.forceNum ~= nil then
		self.forceNum:dispose();
		self.forceNum = nil;
	end
	if self.collectList ~= nil then
		self.collectList:dispose();
		self.collectList = nil;
	end
	if self.noneIcon ~= nil then
		self.noneIcon:dispose();
		self.noneIcon = nil;
	end
	if self.noneText ~= nil then
		self.noneText:dispose();
		self.noneText = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetItem = class("Lua_CollectionCabinetItem", Lua_ListCell)
function Lua_CollectionCabinetItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetItem_skin");
end

function Lua_CollectionCabinetItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
end

function Lua_CollectionCabinetItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local posX = {-219, 0, 219};
	local dataLen = data:getSize();
	local arrLen = self.itemArr:getSize();
	local maxLen = dataLen >= arrLen and dataLen or arrLen;
	local item;
	for i = 1, maxLen do
		item = self.itemArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_CollectionCabinetSingleItem.new(self.content);
				self.itemArr:add(item);
			end
			item.contentName = "Lua_CollectionCabinetSingleItem_"..data[i];
			item:setEnable(true);
			item:setSiblingIndex(2);
			item:setData(data[i]);
			item:setLocation(posX[i], 0, 0);
		end
	end

	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(data[1]);
	local qualityLangVal = DataCenter.collectionCabinetUtil:getCollectionActiveTitleNameByColor(collectVo.color);
	local activeArr = DataCenter.collectionCabinetData:getColllectColorIdsByColor(collectVo.color);
	local totalArr = DataCenter.collectionCabinetUtil:getAllColllectColorIdsByColor(collectVo.color);
	local activeNum = activeArr and activeArr:getSize() or 0;
	local totalNum = totalArr:getSize();
	self.qualityNumBg:setAltas("collection_cabinet_atlas_1", "xui_cpg_quality_" .. collectVo.color);
	self.qualityNumTxt.text = LanUtil.formateStr(qualityLangVal, activeNum, totalNum);
	self.qualityNumBg:setEnable(activeArr and data[1] == activeArr[1]);
	self.qualityNumTxt:setEnable(activeArr and data[1] == activeArr[1]);
end

function Lua_CollectionCabinetItem:onPressClick()
	local item;
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	for i = 1, self._data:getSize() do
		item = self.itemArr[i];
		if item ~= nil and item:checkInBound(winPos.x, winPos.y) then
			item:onPressClick();
			break;
		end
	end
end

function Lua_CollectionCabinetItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_CollectionCabinetSingleItem = class("Lua_CollectionCabinetSingleItem", Lua_ListCell);
function Lua_CollectionCabinetSingleItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetSingleItem_skin");
end

function Lua_CollectionCabinetSingleItem:buildShowItem()
	self:superCall("buildShowItem");
	self.showStarArr = Array();
end

function Lua_CollectionCabinetSingleItem:setData(data)
	self._data = DataCenter.collectionCabinetData:getCollectionCabinetVo(data);
	if data == nil or self._data == nil then
		return;
	end

	self.itemIcon:setAltas(self._data.atlas, self._data.sprite);

	self.nameTxt.text = self._data.name;
	self.levelTxt.text = LanUtil.formateStr(787003, self._data.level);
	self.levelTxt:setEnable(self._data.level > 0);
	self.levelBg:setEnable(self._data.level > 0);

	self:showStar();
	self:showRedDot(self._data.isCanUpStar or self._data.isCanUpLv);
end

function Lua_CollectionCabinetSingleItem:showStar()
	local actualStar = self._data.starLv;
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local maxLen = showStar >= arrLen and showStar or arrLen;
	local width = 24;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.showStarArr[i];
		if showStar > 0 then
			if i > showStar then
				starIcon:setEnable(false);
			else
				if starIcon == nil then
					starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
					self.showStarArr:add(starIcon);
				end
				if 5 >= actualStar then
					starIcon:setAltas("common_altas_1", "xui_common_label_02");
				else
					starIcon:setAltas("common_altas_1", "xui_common_label_03");
				end
				starIcon:resetSize();
				starIcon:setLocation(73 - (i - 1) * width, -50, 0);
				starIcon:setEnable(true);
			end
		else
			starIcon:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetSingleItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(65, 35, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

-- 判断是否范围内
function Lua_CollectionCabinetSingleItem:checkInBound(posX, posY)
	local half_w = self.itemIcon.width / 2;
	local half_h = self.itemIcon.height / 2;
	self.minX = self.posX - half_w;
	self.maxX = self.posX + half_w;
	self.minY = self.posY - half_h;
	self.maxY = self.posY + half_h;
	return posX >= self.minX and posX <= self.maxX and posY >= self.minY and posY <= self.maxY;
end

function Lua_CollectionCabinetSingleItem:onPressClick()
	local isToggle = DataCenter.collectionCabinetData.collectionActiveArr:getSize() > 1;
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDetailWindow", Lua_WinParam.ACTION_OPEN, {data = self._data, showType = 1, isToggle = isToggle});
end

function Lua_CollectionCabinetSingleItem:dispose()
	if self.showStarArr ~= nil then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end