Lua_CollectionCabinetShareWindow = class("Lua_CollectionCabinetShareWindow", Lua_Window);
function Lua_CollectionCabinetShareWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetShareWindow";
	self.skinName = "CollectionCabinetShareWindowskin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.1;
end

function Lua_CollectionCabinetShareWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.worldBtn:addClickFuntion(self, self.onShareWorldClick);
	self.serverBtn:addClickFuntion(self, self.onShareLeagueClick);
end

function Lua_CollectionCabinetShareWindow:showWin(param)
	self:superCall("showWin", param);

	LuaUtil.setObjPos(self.shareObj, 184, param.posY, 0);
	TweenUtil.getInstance():addTweenTargetPos(self.shareObj, 1, 0, 184, param.posY + 75.5, 0, 0, false);
end

function Lua_CollectionCabinetShareWindow:onShareWorldClick()
	local shareMaxTimes = DataCenter.collectionCabinetUtil.shareMaxTimes;
	-- if self.showData.data.shareTimes >= shareMaxTimes then -- 每个藏品分享次数不共用
	if DataCenter.collectionCabinetData.leftShareTimes >= shareMaxTimes then -- 策划要求：每个藏品分享次数共用
		OperateAlert.showLangValue(787009);
	else
		local shareIntervalTime = DataCenter.collectionCabinetUtil.shareIntervalTime;
		local shareTime = DataCenter.collectionCabinetData.shareTime;
		if shareTime < shareIntervalTime then
			OperateAlert.show(LanUtil.formateStr(787010, shareIntervalTime - shareTime));
		else
			local str = LanUtil.formateStr(787011, self.showData.data.name);
			DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_CABINET, self.showData.data.id);
			Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, str, false, true);
		end
	end
end

function Lua_CollectionCabinetShareWindow:onShareLeagueClick()
	local shareMaxTimes = DataCenter.collectionCabinetUtil.shareMaxTimes;
	-- if self.showData.data.shareTimes >= shareMaxTimes then -- 每个藏品分享次数不共用
	if DataCenter.collectionCabinetData.leftShareTimes >= shareMaxTimes then -- 策划要求：每个藏品分享次数共用
		OperateAlert.showLangValue(787009);
	else
		if DataCenter.funcOpenData:isOpened(10229) and DataCenter.roleData:isJoinTheLeague() then
			local shareIntervalTime = DataCenter.collectionCabinetUtil.shareIntervalTime;
			local shareTime = DataCenter.collectionCabinetData.shareTime;
			if shareTime < shareIntervalTime then
				OperateAlert.show(LanUtil.formateStr(787010, shareIntervalTime - shareTime));
			else
				local str = LanUtil.formateStr(787011, self.showData.data.name);
				DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_CABINET, self.showData.data.id);
				Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, str, false, true);
			end
		else
			OperateAlert.showLangValue(787012);
		end
	end
end

function Lua_CollectionCabinetShareWindow:dispose()
	TweenUtil.getInstance():stop(self.shareObj);
	self:superCall("dispose");
end