-- 藏宝柜-升星/升級描述界面
Lua_CollectionCabinetUpDesWindow = class("Lua_CollectionCabinetUpDesWindow", Lua_Window);
function Lua_CollectionCabinetUpDesWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetUpDesWindow";
	self.skinName = "CollectionCabinetUpDesWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.5;
end

function Lua_CollectionCabinetUpDesWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CollectionCabinetUpDesWindow:showWin(param)
	self:superCall("showWin", param);

	if param.upType == 1 then
		self.tispTxt:setLangValue(787042);
	else
		self.tispTxt:setLangValue(787043);
	end

	local id, config
	local desStr = "";
	for i = param.data.initialStar, param.data.maxStar do
		id = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(param.data.id, i);
		if param.upType == 1 then
			config = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(id);
			config = DataCenter.collectionCabinetUtil:getCollectionCabinetEntryConfig(config.special_nature_id);
			if config.show_entry_type == 1 then
				desStr = desStr .. config.title_desc .. "，";
				desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(config.hero_camp) .. "：";
				local attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.prop);
				for i = 1, attrArr:getSize() do
					desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
					if i ~= attrArr:getSize() then
						desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
					end
				end
			elseif config.show_entry_type == 2 then
				desStr = desStr .. config.other_desc;
			elseif config.show_entry_type == 3 then
				desStr = desStr .. config.title_desc .. "，";
				desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(config.hero_camp) .. "：";
				local attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.prop);
				for i = 1, attrArr:getSize() do
					desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
					if i ~= attrArr:getSize() then
						desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
					end
				end
				desStr = desStr .. "，" .. config.other_desc;
			end
		else
			config = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(id);
			id = DataCenter.collectionCabinetUtil:getCollectionCabinetLvId(param.data.levelNormalType, config.max_level);
			config = DataCenter.collectionCabinetUtil:getCollectionCabinetLvConfig(id);
			desStr = desStr .. config.level_des;
		end
		if i ~= param.data.maxStar then
			desStr = desStr .. "\n";
		end
	end
	self.desTxt.text = desStr;
	self.desTxt:resetSize();
	self.winBg:SetDimensions(340, self.winBg.posY - (self.desTxt.posY - self.desTxt.height) + 21);
end

function Lua_CollectionCabinetUpDesWindow:dispose()
	self:superCall("dispose");
end










Lua_CollectionCabinetUpDesItem = class("Lua_CollectionCabinetUpDesItem", Lua_ListCell);
function Lua_CollectionCabinetUpDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", 0, 0, 350, 0, 22);
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.alignmentValue = 0;
end

function Lua_CollectionCabinetUpDesItem:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = data;
	self.desTxt:resetSize();
end

function Lua_CollectionCabinetUpDesItem:getWidth()
	return self.desTxt.width;
end

function Lua_CollectionCabinetUpDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_CollectionCabinetUpDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end