-- 藏宝柜-强化/升級界面
Lua_CollectionCabinetUpLvWindow = class("Lua_CollectionCabinetUpLvWindow", Lua_Window);
function Lua_CollectionCabinetUpLvWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetUpLvWindow";
	self.skinName = "CollectionCabinetUpLvWindow_skin";
	self.layer = Lua_MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -565;
end

function Lua_CollectionCabinetUpLvWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showStarArr = Array();

	self.upLvList = Lua_DragList.new(self.content, 264, 70, Lua_AxisDefine.Vertical);
	self.upLvList:setListCell(Lua_CollectionCabinetUpLvItem, 264, 30, 1);
	self.upLvList:setCellSpacing(0, 10);
	self.upLvList:setLocation(103, 200, 0);

	self.desDragContainer = Lua_DragContainer.new(self.content, 592, 172, Lua_AxisDefine.Vertical);
	self.desDragContainer:setCellSpacing(0, 5);
	self.desDragContainer:setLocation(0, -6.5, 0);

	self.costList = Lua_DragList.new(self.upLvObj, 500, 133, Lua_AxisDefine.Horizontal);
	self.costList:setListCell(Lua_CollectionCabinetUpLvCostItem, 100, 133, 1);
	self.costList:setCellSpacing(24, 0);

	self.leftBtn:addClickFuntion(self, self.onLeftClick);
	self.rightBtn:addClickFuntion(self, self.onRightClick);
	self.upBtn:addClickFuntion(self, self.onUpLvClick);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_INFO", self, self.showUpLvInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.showUpLvInfo);
	self:addLuaEvent("MONEY_UPDATE", self, self.showUpLvInfo);
end

function Lua_CollectionCabinetUpLvWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	self.startIdx = 1;
	self.maxIdx = arr:getSize();
	for i = 1, self.maxIdx do
		if param.data.id == arr[i] then
			self.moveIdx = i;
			break;
		end
	end
	self.leftBtn:setEnable(param.isToggle);
	self.rightBtn:setEnable(param.isToggle);
	self:showUpLvInfo(param.data, true);
end

function Lua_CollectionCabinetUpLvWindow:showUpLvInfo(collectVo, isSet)
	if isSet then
		self.collectVo = collectVo;
	end

	self.itemIcon:setAltas(self.collectVo.atlas, self.collectVo.sprite);
	self.nameTxt.text = self.collectVo.name;
	self.levelTxt.text = LanUtil.formateStr(787047, self.collectVo.level, self.collectVo.maxLevel);
	self.desTxt_3.text = LanUtil.formateStr(787013, self.collectVo.curMaxLv);

	local attrDic = self:getPropDic(self.collectVo.starNormalProp, self.collectVo.lvNormalProp, attrDic);
	local attrArr;
	if self.collectVo.isMaxLv then
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	else
		local curLvProp = DataCenter.attributesUtil:getAttrDic(self.collectVo.lvNormalProp);
		local nextLvId = DataCenter.collectionCabinetUtil:getCollectionCabinetLvId(self.collectVo.levelNormalType, self.collectVo.level + 1);
		local nextLvConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetLvConfig(nextLvId);
		local nextLvProp = {};
		if nextLvConfig.normal_prop then
			for k,v in pairs(nextLvConfig.normal_prop) do
				if curLvProp[k] and curLvProp[k] >= v then
					nextLvProp[k] = 0;
				else
					nextLvProp[k] = v - (curLvProp[k] or 0);
				end
			end
		end
		for k,v in pairs(nextLvProp) do
			if attrDic[k] == nil then
				attrDic[k] = 0;
			end
		end
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic, nextLvProp);
	end
	self.upLvList.canDrag = attrArr:getSize() > 2;
	self.upLvList:setArrayData(attrArr);

	local config, colorStr;
	local height = self.collectVo.isMaxLv and 372 or 172;
	local posY = self.collectVo.isMaxLv and -106.5 or -6.5;
	self.desDragContainer:setContentRect(592, height);
	self.desDragContainer:setLocation(0, posY, 0);
	self.desDragContainer:clearList();
	for i = self.collectVo.initialStar, self.collectVo.maxStar do
		starId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(self.collectVo.id, i);
		starConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(starId);
		if starConfig then
			levelId = DataCenter.collectionCabinetUtil:getCollectionCabinetLvId(self.collectVo.levelNormalType, starConfig.max_level);
			self.desDragContainer:addSubContainer(Lua_CollectionCabinetUpLvDesItem, {curLv = self.collectVo.level, maxLv = starConfig.max_level, levelId = levelId});
		end
	end
	self.desDragContainer:updateChildPos();
	self.desDragContainer:moveToIndex(1, true, false);
	self.desDragContainer.canDrag = not self.desDragContainer.isTheEnd;

	if not self.collectVo.isMaxLv then
		local len = #self.collectVo.upLvCostList;
		local posX = len > 5 and 0 or (500 - len * 124 + 24) / 2;
		self.costList.canDrag = len > 5;
		self.costList:setArrayData(self.collectVo.upLvCostList);
		self.costList:setLocation(posX, -232, 0);
	end
	self.upLvObj:SetActive(not self.collectVo.isMaxLv);
	self.maxBg:setEnable(self.collectVo.isMaxLv);
	self.maxTxt:setEnable(self.collectVo.isMaxLv);

	self:showStarFun(self.collectVo.starLv);
end

function Lua_CollectionCabinetUpLvWindow:getPropDic(starProp, lvProp, attrDic)
	attrDic = DataCenter.attributesUtil:getAttrDic(starProp, attrDic);
	attrDic = DataCenter.attributesUtil:getAttrDic(lvProp, attrDic);
	return attrDic;
end

function Lua_CollectionCabinetUpLvWindow:showStarFun(actualStar)
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local maxLen = showStar > arrLen and showStar or arrLen;
	local width = 24;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.showStarArr[i];
		if i > showStar then
			if starIcon then
				starIcon:setEnable(false);
			end
		else
			if starIcon == nil then
				starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
				self.showStarArr:add(starIcon);
			end
			starIcon:setEnable(true);
			starIcon:setLocation(64 + width * (i - 1), 260, 0);
			if 5 >= actualStar then
				starIcon:setAltas("common_altas_1", "xui_common_label_02");
			else
				starIcon:setAltas("common_altas_1", "xui_common_label_03");
			end
		end
	end
end

function Lua_CollectionCabinetUpLvWindow:onLeftClick(go)
	if self.moveIdx - 1 < self.startIdx then
		self.moveIdx = self.maxIdx + 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx - 1;
	self:onToggleFun(self.startIdx);
end

function Lua_CollectionCabinetUpLvWindow:onRightClick(go)
	if self.moveIdx + 1 > self.maxIdx then
		self.moveIdx = self.startIdx - 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx + 1;
	self:onToggleFun();
end

function Lua_CollectionCabinetUpLvWindow:onToggleFun()
	-- self.leftBtn:setEnable(self.moveIdx > self.startIdx and self.showData.isToggle);
	-- self.rightBtn:setEnable(self.moveIdx < self.maxIdx and self.showData.isToggle);
	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	local collectId = arr[self.moveIdx];
	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(collectId);
	self:showUpLvInfo(collectVo, true);
end

function Lua_CollectionCabinetUpLvWindow:onUpLvClick(go)
	if self.checkTime and getTime() - self.checkTime < 0.5 then
		OperateAlert.showLangValue(787045);
		return;
	end
	self.checkTime = getTime();

	if self.collectVo.isMaxLv then
		OperateAlert.showLangValue(787014);
	elseif not self.collectVo.isMaxStar and self.collectVo.isCurMaxLv then
		OperateAlert.showLangValue(787015);
	else
		if self.collectVo.isCanUpLv then
			Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetOpertate(self.collectVo.id, 2);
		else
			local list = self.collectVo.upLvCostList;
			local hasNum, itemId;
			for i = 1, #list do
				hasNum = DataCenter.packData:getItemCountById(list[i][1]);
				if hasNum < list[i][2] then
					itemId = list[i][1];
					break;
				end
			end
			DataCenter.packUtil:openPathWindow(itemId);
		end
	end
end

function Lua_CollectionCabinetUpLvWindow:dispose()
	if self.showStarArr ~= nil then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	if self.upLvList ~= nil then
		self.upLvList:dispose();
		self.upLvList = nil;
	end
	if self.desDragContainer ~= nil then
		self.desDragContainer:dispose();
		self.desDragContainer = nil;
	end
	if self.costList ~= nil then
		self.costList:dispose();
		self.costList = nil;
	end
	self.collectVo = nil;
	self:superCall("dispose");
end










Lua_CollectionCabinetUpLvItem = class("Lua_CollectionCabinetUpLvItem", Lua_ListCell);
function Lua_CollectionCabinetUpLvItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpLvItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desBg = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_1", "xui_cpg_widget_31", 0, 0, 264, 30);
	self.desTxt = UICreate.createLabel(self.content, nil, -119, 0, 100, 31, 24);
	self.desTxt.pivotValue = 3;
	self.desTxt.alignmentValue = 3;
	self.desTxt.horizontalOverflowValue = 1;
	self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_CollectionCabinetUpLvItem:setData(data)
	if data == nil then
		return;
	end

	if data.nextValue == 0 then
		self.desTxt.text = LanUtil.formateStr(787016, data.show_name, data.showValue);
	else
		self.desTxt.text = LanUtil.formateStr(787017, data.show_name, data.showValue, data.showNextValue);
	end
end

function Lua_CollectionCabinetUpLvItem:dispose()
	if self.desBg ~= nil then
		self.desBg:dispose();
		self.desBg = nil;
	end
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetUpLvDesItem = class("Lua_CollectionCabinetUpLvDesItem", Lua_DragContainerItem);
function Lua_CollectionCabinetUpLvDesItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetUpLvDesItem_skin");
end

function Lua_CollectionCabinetUpLvDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CollectionCabinetUpLvDesItem:setData(data)
	if data == nil then
		return;
	end

	local colorStr = data.maxLv > data.curLv and "4D4B4D" or "489053";
	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetLvConfig(data.levelId);
	self.levelTxt.text = LanUtil.formateStr(787046, data.maxLv);
	self.levelTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.desTxt.text = config.level_des;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.desTxt:resetSize();
end

function Lua_CollectionCabinetUpLvDesItem:getWidth()
	return 592;
end

function Lua_CollectionCabinetUpLvDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_CollectionCabinetUpLvDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetUpLvCostItem = class("Lua_CollectionCabinetUpLvCostItem", Lua_ListCell);
function Lua_CollectionCabinetUpLvCostItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpLvCostItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 16.5, 0);
	self.itemIcon:setScale(0.8, 0.8);

	self.costTxt = UICreate.createLabel(self.content, nil, 0, -54.5, 100, 31, 24);
	self.costTxt.horizontalOverflowValue = 1;
	self.costTxt.alignmentValue = 4;
	self.costTxt.fontName = Lua_MyUISettings.fangzhengFontName;
end

function Lua_CollectionCabinetUpLvCostItem:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data[1]);
	local curCount = DataCenter.packData:getItemCountById(data[1]);
	self.itemIcon:setData(tvo);

	local colorStr = curCount >= data[2] and "4D4B4D" or "E9513D";
	self.costTxt.text = LanUtil.formateStr(787018, colorStr, numberTrans(curCount), numberTrans(data[2]));
	self.costTxt:resetSize();
	if self.costTxt.width > 100 then
		self.costTxt:setEnable(false);
		if self.scrollText == nil then
			self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 100, 24);
			self.scrollText:setLocation(0, self.costTxt.posY, 0);
			self.scrollText:setTextStyle(100, 24, Lua_MyUISettings.fangzhengFontName, 24, "FFFFFF", 0, "FFFFFF");
		end
		self.scrollText:setEnable(true);
		self.scrollText:setShowTxt(self.costTxt.text);
	else
		self.costTxt:setEnable(true);
		if self.scrollText then
			self.scrollText:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetUpLvCostItem:checkInBound(posX, posY)
	local minX = self.centerPosX + self.itemIcon.posX - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.centerPosX + self.itemIcon.posX + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.centerPosY + self.itemIcon.posY - self.itemIcon.itemH * self.itemIcon.scaleX / 2;
	local maxY = self.centerPosY + self.itemIcon.posY + self.itemIcon.itemH * self.itemIcon.scaleX / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_CollectionCabinetUpLvCostItem:onPressClick()
	self.itemIcon:onItemClick();
end

function Lua_CollectionCabinetUpLvCostItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.costTxt ~= nil then
		self.costTxt:dispose();
		self.costTxt = nil;
	end
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self:superCall("dispose");
end