-- 藏宝柜-升星成功界面
Lua_CollectionCabinetUpStarSucceedWindow = class("Lua_CollectionCabinetUpStarSucceedWindow", Lua_Window);
function Lua_CollectionCabinetUpStarSucceedWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetUpStarSucceedWindow";
	self.skinName = "CollectionCabinetUpStarSucceedWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -479;

	self:addPreLoadRes("/images/common/xui_common_bg_002.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/common/xui_common_window_010.png", Lua_LoadFileType.IMG);
end

function Lua_CollectionCabinetUpStarSucceedWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.preItemIcon = Lua_ItemIcon.new(self.content);
	self.preItemIcon:setLocation(-150, 340, 0);

	self.curItemIcon = Lua_ItemIcon.new(self.content);
	self.curItemIcon:setLocation(150, 340, 0);
end

function Lua_CollectionCabinetUpStarSucceedWindow:showWin(param)
	self:superCall("showWin", param);

	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(param);
	OperateAlert.show(LanUtil.formateStr(787048, collectVo.name));

	local preStarLv = collectVo.starLv - 1;
	local preStarId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(collectVo.id, preStarLv);
	local preStarConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(preStarId);
	local preStarProp = preStarConfig.normal_prop or {};
	local curPropDic = collectVo.starNormalProp;
	local prePropDic = {};
	for k,v in pairs(preStarProp) do
		prePropDic[k] = v;
	end
	for k,v in pairs(curPropDic) do
		if prePropDic[k] == nil then
			prePropDic[k] = 0;
		end
	end
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(prePropDic, curPropDic);
	local item;
	self.showItemArr = Array();
	for i = 1, attrArr:getSize() do
		item = Lua_CollectionCabinetUpStarTipsItem.new(self.content);
		item.contentName = "Lua_CollectionCabinetUpStarTipsItem_" .. i;
		item:setLocation(0, 67 - 46 * (i - 1));
		item:setData(attrArr[i], i);
		self.showItemArr:add(item);
	end
	self.starDesTxt_1.text = self:getDesFun(DataCenter.collectionCabinetUtil:getCollectionCabinetEntryConfig(preStarConfig.special_nature_id));
	self.starDesTxt_2.text = self:getDesFun(collectVo.starEntryConfig);

	self.preItemIcon:setData(collectVo.tvo);
	self.curItemIcon:setData(collectVo.tvo);
	self:showStarFun(preStarLv, self.preItemIcon.posX);
	self:showStarFun(collectVo.starLv, self.curItemIcon.posX);
end

function Lua_CollectionCabinetUpStarSucceedWindow:getDesFun(starEntryConfig)
	local attrVo;
	local desStr = "";
	if starEntryConfig then
		if starEntryConfig.show_entry_type == 1 then
			desStr = starEntryConfig.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";
			local attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
		elseif starEntryConfig.show_entry_type == 2 then
			desStr = starEntryConfig.other_desc;
		elseif starEntryConfig.show_entry_type == 3 then
			desStr = starEntryConfig.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(starEntryConfig.hero_camp) .. "：";
			local attrArr = DataCenter.attributesUtil:getAttrArrByDic(starEntryConfig.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
			desStr = desStr .. "，" .. starEntryConfig.other_desc;
		end
	end
	return desStr;
end

function Lua_CollectionCabinetUpStarSucceedWindow:showStarFun(actualStar, posX)
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local width = 13;
	local startPosX = posX - (width * showStar) / 2 + width / 2;
	local starIcon;
	for i = 1, showStar do
		starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
		starIcon:setLocation(startPosX + ((i - 1) % showStar) * width, 286, 0);
		if 5 >= actualStar then
			starIcon:setAltas("common_altas_1", "xui_common_label_09");
		else
			starIcon:setAltas("common_altas_1", "xui_common_label_10");
		end
	end
end

function Lua_CollectionCabinetUpStarSucceedWindow:dispose()
	if self.preItemIcon ~= nil then
		self.preItemIcon:dispose();
		self.preItemIcon = nil;
	end
	if self.curItemIcon ~= nil then
		self.curItemIcon:dispose();
		self.curItemIcon = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	DataCenter.collectionCabinetData:showUpStarCollection();
	self:superCall("dispose");
end










Lua_CollectionCabinetUpStarTipsItem = class("Lua_CollectionCabinetUpStarTipsItem", Lua_DisplayObject);
function Lua_CollectionCabinetUpStarTipsItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpStarTipsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_window_010_3", 0, -3, 720, 39);

	self.attrTxt = UICreate.createLabel(self.content, nil, -136, 0, 100, 31, 26);
	self.attrTxt.verticalOverflowValue = 1;
	self.attrTxt.alignmentValue = 3;
	self.attrTxt.fontName = Lua_MyUISettings.huakangFontName;

	self.preValTxt = UICreate.createLabel(self.content, nil, -39, 0, 100, 31, 26);
	self.preValTxt.verticalOverflowValue = 1;
	self.preValTxt.alignmentValue = 3;
	self.preValTxt.fontName = Lua_MyUISettings.huakangFontName;

	self.toggleIcon = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_1", "xui_gwtz_label_1", 0, 0, 0, 0);

	self.curValTxt = UICreate.createLabel(self.content, nil, 103, 0, 100, 31, 26);
	self.curValTxt.verticalOverflowValue = 1;
	self.curValTxt.alignmentValue = 5;
	self.curValTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.curValTxt.colorStr = Lua_ColorDefine.transColorStr("F7EDCC");
end

function Lua_CollectionCabinetUpStarTipsItem:setData(data, idx)
	self.itemBg:setEnable(idx % 2 == 0);
	self.attrTxt.text = data.show_name;
	self.preValTxt.text = data.showValue;
	self.curValTxt.text = data.showNextValue;
end

function Lua_CollectionCabinetUpStarTipsItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.attrTxt ~= nil then
		self.attrTxt:dispose();
		self.attrTxt = nil;
	end
	if self.preValTxt ~= nil then
		self.preValTxt :dispose();
		self.preValTxt = nil;
	end
	if self.toggleIcon ~= nil then
		self.toggleIcon :dispose();
		self.toggleIcon = nil;
	end
	if self.curValTxt ~= nil then
		self.curValTxt :dispose();
		self.curValTxt = nil;
	end
	self:superCall("dispose");
end