-- 藏宝柜-强化/升星界面
Lua_CollectionCabinetUpStarWindow = class("Lua_CollectionCabinetUpStarWindow", Lua_Window);
function Lua_CollectionCabinetUpStarWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetUpStarWindow";
	self.skinName = "CollectionCabinetUpStarWindow_skin";
	self.layer = Lua_MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -565;
end

function Lua_CollectionCabinetUpStarWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showStarArr = Array();

	self.upStarList = Lua_DragList.new(self.content, 264, 70, Lua_AxisDefine.Vertical);
	self.upStarList:setListCell(Lua_CollectionCabinetUpStarItem, 264, 30, 1);
	self.upStarList:setCellSpacing(0, 10);
	self.upStarList:setLocation(103, 200, 0);

	self.desDragContainer = Lua_DragContainer.new(self.content, 592, 172, Lua_AxisDefine.Vertical);
	self.desDragContainer:setCellSpacing(0, 5);

	self.costList = Lua_DragList.new(self.upStarObj, 500, 133, Lua_AxisDefine.Horizontal);
	self.costList:setListCell(Lua_CollectionCabinetUpStarCostItem, 100, 133, 1);
	self.costList:setCellSpacing(24, 0);

	self.leftBtn:addClickFuntion(self, self.onLeftClick);
	self.rightBtn:addClickFuntion(self, self.onRightClick);
	self.upBtn:addClickFuntion(self, self.onUpStarClick);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_INFO", self, self.showUpStarInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.showUpStarInfo);
	self:addLuaEvent("MONEY_UPDATE", self, self.showUpStarInfo);
end

function Lua_CollectionCabinetUpStarWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	self.startIdx = 1;
	self.maxIdx = arr:getSize();
	for i = 1, self.maxIdx do
		if param.data.id == arr[i] then
			self.moveIdx = i;
			break;
		end
	end
	self.leftBtn:setEnable(param.isToggle);
	self.rightBtn:setEnable(param.isToggle);
	self:showUpStarInfo(param.data, true);
end

function Lua_CollectionCabinetUpStarWindow:showUpStarInfo(collectVo, isSet)
	if isSet then
		self.collectVo = collectVo;
	end

	self.itemIcon:setAltas(self.collectVo.atlas, self.collectVo.sprite);
	self.nameTxt.text = self.collectVo.name;
	self.levelTxt.text = LanUtil.formateStr(787047, self.collectVo.level, self.collectVo.maxLevel);
	self.desTxt_3.text = LanUtil.formateStr(787019, self.collectVo.maxStar);

	local attrDic = self:getPropDic(self.collectVo.starNormalProp, self.collectVo.lvNormalProp, attrDic);
	local attrArr;
	if self.collectVo.isMaxStar then
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	else
		local curStarProp = DataCenter.attributesUtil:getAttrDic(self.collectVo.starNormalProp);
		local nextStarId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(self.collectVo.id, self.collectVo.starLv + 1);
		local nextStarConfig = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(nextStarId);
		local nextStarProp = {};
		if nextStarConfig.normal_prop then
			for k,v in pairs(nextStarConfig.normal_prop) do
				if curStarProp[k] and curStarProp[k] >= v then
					nextStarProp[k] = 0;
				else
					nextStarProp[k] = v - (curStarProp[k] or 0);
				end
			end
		end
		for k,v in pairs(nextStarProp) do
			if attrDic[k] == nil then
				attrDic[k] = 0;
			end
		end
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic, nextStarProp);
	end
	self.upStarList.canDrag = attrArr:getSize() > 2;
	self.upStarList:setArrayData(attrArr);

	local starId, config, desStr;
	local height = self.collectVo.isMaxStar and 372 or 172;
	local posY = self.collectVo.isMaxStar and -106.5 or -6.5;
	self.desDragContainer:setContentRect(592, height);
	self.desDragContainer:setLocation(0, posY, 0);
	self.desDragContainer:clearList();
	for i = self.collectVo.initialStar, self.collectVo.maxStar do
		starId = DataCenter.collectionCabinetUtil:getCollectionCabinetStarId(self.collectVo.id, i);
		config = DataCenter.collectionCabinetUtil:getCollectionCabinetStarConfig(starId);
		config = DataCenter.collectionCabinetUtil:getCollectionCabinetEntryConfig(config.special_nature_id);
		if config.show_entry_type == 1 then
			desStr = config.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(config.hero_camp) .. "：";
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "<color=#D2752C>+" .. attrArr[i].showValue .. "</color>";
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
		elseif config.show_entry_type == 2 then
			desStr = config.other_desc;
		elseif config.show_entry_type == 3 then
			desStr = config.title_desc .. "，";
			desStr = desStr .. DataCenter.collectionCabinetUtil:getStarEntryGrowUpDesByCamp(config.hero_camp) .. "：";
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.prop);
			for i = 1, attrArr:getSize() do
				desStr = desStr .. attrArr[i].show_name .. "<color=#D2752C>+" .. attrArr[i].showValue .. "</color>";
				if i ~= attrArr:getSize() then
					desStr = desStr .. Lua_SpaceDefine.SPACE_TIME;
				end
			end
			desStr = desStr .. "，" .. config.other_desc;
		end
		self.desDragContainer:addSubContainer(Lua_CollectionCabinetUpStarDesItem, {showStar = i, curStar = self.collectVo.starLv, des = desStr});
	end
	self.desDragContainer:updateChildPos();
	self.desDragContainer:moveToIndex(1, true, false);
	self.desDragContainer.canDrag = not self.desDragContainer.isTheEnd;

	if not self.collectVo.isMaxStar then
		local len = #self.collectVo.upStarCostList;
		local posX = len > 5 and 0 or (500 - len * 124 + 24) / 2;
		self.costList.canDrag = len > 5;
		self.costList:setArrayData(self.collectVo.upStarCostList);
		self.costList:setLocation(posX, -232, 0);
	end
	self.upStarObj:SetActive(not self.collectVo.isMaxStar);
	self.maxBg:setEnable(self.collectVo.isMaxStar);
	self.maxTxt:setEnable(self.collectVo.isMaxStar);

	self:showStarFun(self.collectVo.starLv);
end

function Lua_CollectionCabinetUpStarWindow:getPropDic(starProp, lvProp, attrDic)
	attrDic = DataCenter.attributesUtil:getAttrDic(starProp, attrDic);
	attrDic = DataCenter.attributesUtil:getAttrDic(lvProp, attrDic);
	return attrDic;
end

function Lua_CollectionCabinetUpStarWindow:showStarFun(actualStar)
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local maxLen = showStar > arrLen and showStar or arrLen;
	local width = 24;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.showStarArr[i];
		if i > showStar then
			if starIcon then
				starIcon:setEnable(false);
			end
		else
			if starIcon == nil then
				starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
				self.showStarArr:add(starIcon);
			end
			starIcon:setEnable(true);
			starIcon:setLocation(64 + width * (i - 1), 260, 0);
			if 5 >= actualStar then
				starIcon:setAltas("common_altas_1", "xui_common_label_02");
			else
				starIcon:setAltas("common_altas_1", "xui_common_label_03");
			end
		end
	end
end

function Lua_CollectionCabinetUpStarWindow:onLeftClick(go)
	if self.moveIdx - 1 < self.startIdx then
		self.moveIdx = self.maxIdx + 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx - 1;
	self:onToggleFun(self.startIdx);
end

function Lua_CollectionCabinetUpStarWindow:onRightClick(go)
	if self.moveIdx + 1 > self.maxIdx then
		self.moveIdx = self.startIdx - 1; -- 策划要求一直循环
		-- return;
	end
	self.moveIdx = self.moveIdx + 1;
	self:onToggleFun();
end

function Lua_CollectionCabinetUpStarWindow:onToggleFun()
	-- self.leftBtn:setEnable(self.moveIdx > self.startIdx and self.showData.isToggle);
	-- self.rightBtn:setEnable(self.moveIdx < self.maxIdx and self.showData.isToggle);
	local arr = DataCenter.collectionCabinetData.collectionActiveArr;
	local collectId = arr[self.moveIdx];
	local collectVo = DataCenter.collectionCabinetData:getCollectionCabinetVo(collectId);
	self:showUpStarInfo(collectVo, true);
end

function Lua_CollectionCabinetUpStarWindow:onUpStarClick(go)
	if self.checkTime and getTime() - self.checkTime < 0.5 then
		OperateAlert.showLangValue(787045);
		return;
	end
	self.checkTime = getTime();

	if self.collectVo.isCanUpStar then
		Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetOpertate(self.collectVo.id, 1);
	else
		local list = self.collectVo.upStarCostList;
		local hasNum, itemId;
		for i = 1, #list do
			hasNum = DataCenter.packData:getItemCountById(list[i][1]);
			if hasNum < list[i][2] then
				itemId = list[i][1];
				break;
			end
		end
		DataCenter.packUtil:openPathWindow(itemId);
	end
end

function Lua_CollectionCabinetUpStarWindow:dispose()
	if self.showStarArr ~= nil then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	if self.upStarList ~= nil then
		self.upStarList:dispose();
		self.upStarList = nil;
	end
	if self.desDragContainer ~= nil then
		self.desDragContainer:dispose();
		self.desDragContainer = nil;
	end
	if self.costList ~= nil then
		self.costList:dispose();
		self.costList = nil;
	end
	self.collectVo = nil;
	self:superCall("dispose");
end










Lua_CollectionCabinetUpStarItem = class("Lua_CollectionCabinetUpStarItem", Lua_ListCell);
function Lua_CollectionCabinetUpStarItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpStarItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desBg = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_1", "xui_cpg_widget_31", 0, 0, 264, 30);
	self.desTxt = UICreate.createLabel(self.content, nil, -119, 0, 100, 31, 24);
	self.desTxt.pivotValue = 3;
	self.desTxt.alignmentValue = 3;
	self.desTxt.horizontalOverflowValue = 1;
	self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_CollectionCabinetUpStarItem:setData(data)
	if data == nil then
		return;
	end

	if data.nextValue == 0 then
		self.desTxt.text = LanUtil.formateStr(787020, data.show_name, data.showValue);
	else
		self.desTxt.text = LanUtil.formateStr(787021, data.show_name, data.showValue, data.showNextValue);
	end
end

function Lua_CollectionCabinetUpStarItem:dispose()
	if self.desBg ~= nil then
		self.desBg:dispose();
		self.desBg = nil;
	end
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetUpStarDesItem = class("Lua_CollectionCabinetUpStarDesItem", Lua_ListCell);
function Lua_CollectionCabinetUpStarDesItem:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetUpStarDesItem_skin");
end

function Lua_CollectionCabinetUpStarDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CollectionCabinetUpStarDesItem:setData(data)
	if data == nil then
		return;
	end

	local colorStr = data.showStar > data.curStar and "4D4B4D" or "489053";
	self.levelTxt.text = LanUtil.formateStr(787049, data.showStar);
	self.levelTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.desTxt.text = data.des;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
	self.desTxt:resetSize();
end

function Lua_CollectionCabinetUpStarDesItem:getWidth()
	return 592;
end

function Lua_CollectionCabinetUpStarDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_CollectionCabinetUpStarDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetUpStarCostItem = class("Lua_CollectionCabinetUpStarCostItem", Lua_ListCell);
function Lua_CollectionCabinetUpStarCostItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetUpStarCostItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 16.5, 0);
	self.itemIcon:setScale(0.8, 0.8);

	self.costTxt = UICreate.createLabel(self.content, nil, 0, -54.5, 100, 31, 24);
	self.costTxt.horizontalOverflowValue = 1;
	self.costTxt.alignmentValue = 4;
	self.costTxt.fontName = Lua_MyUISettings.fangzhengFontName;
end

function Lua_CollectionCabinetUpStarCostItem:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data[1]);
	local curCount = DataCenter.packData:getItemCountById(data[1]);
	self.itemIcon:setData(tvo);

	local colorStr = curCount >= data[2] and "4D4B4D" or "E9513D";
	self.costTxt.text = LanUtil.formateStr(787022, colorStr, numberTrans(curCount), numberTrans(data[2]));
	self.costTxt:resetSize();
	if self.costTxt.width > 100 then
		self.costTxt:setEnable(false);
		if self.scrollText == nil then
			self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 100, 24);
			self.scrollText:setLocation(0, self.costTxt.posY, 0);
			self.scrollText:setTextStyle(100, 24, Lua_MyUISettings.fangzhengFontName, 24, "FFFFFF", 0, "FFFFFF");
		end
		self.scrollText:setEnable(true);
		self.scrollText:setShowTxt(self.costTxt.text);
	else
		self.costTxt:setEnable(true);
		if self.scrollText then
			self.scrollText:setEnable(false);
		end
	end
end

function Lua_CollectionCabinetUpStarCostItem:checkInBound(posX, posY)
	local minX = self.centerPosX + self.itemIcon.posX - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.centerPosX + self.itemIcon.posX + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.centerPosY + self.itemIcon.posY - self.itemIcon.itemH * self.itemIcon.scaleX / 2;
	local maxY = self.centerPosY + self.itemIcon.posY + self.itemIcon.itemH * self.itemIcon.scaleX / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_CollectionCabinetUpStarCostItem:onPressClick()
	self.itemIcon:onItemClick();
end

function Lua_CollectionCabinetUpStarCostItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.costTxt ~= nil then
		self.costTxt:dispose();
		self.costTxt = nil;
	end
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self:superCall("dispose");
end