-- 藏品柜-下期大奖
Lua_CollectionCabinetDrawNextPrizeWindow = class("Lua_CollectionCabinetDrawNextPrizeWindow", Lua_Window);
function Lua_CollectionCabinetDrawNextPrizeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetDrawNextPrizeWindow";
	self.skinName = "CollectionCabinetDrawNextPrizeWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.01;
end

function Lua_CollectionCabinetDrawNextPrizeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.nextPeriodList = Lua_DragList.new(self.content, 280, 100, Lua_AxisDefine.Horizontal);
	self.nextPeriodList:setListCell(Lua_CollectionCabinetDrawNextPrizeRewardItem, 100, 100, 1);
	self.nextPeriodList:setCellSpacing(36, 0);
end

function Lua_CollectionCabinetDrawNextPrizeWindow:showWin(param)
	self:superCall("showWin", param);

	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetPeriodConfig(DataCenter.collectionCabinetData.nextPeriodId);
	local list = param == 1 and config.low_up_role or config.up_role;
	local posX = #list > 2 and 117 or 117 + (280 - #list * 136 + 36) / 2;
	self.nextPeriodList.canDrag = #list > 2;
	self.nextPeriodList:setArrayData(list);
	self.nextPeriodList:setLocation(posX, -135, 0);
end

function Lua_CollectionCabinetDrawNextPrizeWindow:dispose()
	if self.nextPeriodList ~= nil then
		self.nextPeriodList:dispose();
		self.nextPeriodList = nil;
	end
	self:superCall("dispose");
end











Lua_CollectionCabinetDrawNextPrizeRewardItem = class("Lua_CollectionCabinetDrawNextPrizeRewardItem", Lua_ItemIconCell);
function Lua_CollectionCabinetDrawNextPrizeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetDrawNextPrizeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.8, 0.8);

	local posX = self.itemIcon.itemW * self.itemIcon.scaleX / 2 - 16;
	local posY = self.itemIcon.itemH * self.itemIcon.scaleY / 2 - 9;
	self.upIcon = UICreate.createUIAtlasImage(self.content, "common_altas_5", "xui_common_label_37", posX, posY, 0, 0);
end

function Lua_CollectionCabinetDrawNextPrizeRewardItem:setData(data)
	if data == nil then
		return ;
	end

	self.data = Lua_ToolVo.createToolVo(data[1][1], data[1][2]);
	self.itemIcon:setData(self.data);
end

function Lua_CollectionCabinetDrawNextPrizeRewardItem:dispose()
	if self.upIcon ~= nil then
		self.upIcon:dispose();
		self.upIcon = nil;
	end
	self:superCall("dispose");
end