-- 藏宝柜-抽奖界面
Lua_CollectionCabinetDrawPanel = class("Lua_CollectionCabinetDrawPanel", Lua_DisplayObject);
function Lua_CollectionCabinetDrawPanel:ctor(p)
	self:superCall("ctor", p, "CollectionCabinetDrawPanel_skin");
end

function Lua_CollectionCabinetDrawPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.isDelayShowRecord = false; -- 是否延后显示记录信息
	self.recordBroadcastIdArr = Array();
	self.showImg_2:setEnable(false);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_PRIZEDRAW_INFO", self, self.updateDrawPanelInfo);
	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_PRIZEDRAW", self, self.updateDrawRewardInfo);
	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_DRAWRECORD_INFO", self, self.updateDrawRecordInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCostShow);
	self:addLuaEvent("ON_NEW_COLLECTION_CABINET_ONE_DRAW", self, self.onOneDrawClick);
	self:addLuaEvent("ON_NEW_COLLECTION_CABINET_TEN_DRAW", self, self.onMoreDrawClick);

	self.maskObj:SetActive(false);

	self.posList = {
		{-261, 330}, {-130.5, 330}, {0, 330}, {130.5, 330},
		{261, 330}, {261, 200}, {261, 70}, {261, -60},
		{261, -190}, {130.5, -190}, {0, -190}, {-130.5, -190},
		{-261, -190}, {-261, -61}, {-261, 70}, {-261, 201}
	};
	self.showItemArr = Array();

	self.curPeriodList = Lua_DragList.new(self.showObj_1, 260, 100, Lua_AxisDefine.Horizontal);
	self.curPeriodList:setListCell(Lua_CollectionCabinetDrawRewardItem, 100, 100, 1);
	self.curPeriodList:setCellSpacing(10, 0);
	self.curPeriodList:setSiblingIndex(self.desIcon.siblingIndex + 1);

	self.moreDrawRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.NewCollectionCabinet_Draw_LowMoreDraw);
	-- self.moreDrawRedPoint:setRectAnchor(7);
	self.moreDrawRedPoint:setLocation(273, -393, 0);

	local btnInfo = Array();
	btnInfo:add({drawType = 1, redPointId = Lua_RedPointList.NewCollectionCabinet_Draw_LowMoreDraw});
	btnInfo:add({drawType = 2, redPointId = Lua_RedPointList.NewCollectionCabinet_Draw_MoreDraw});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setSiblingIndex(self.showImg_1.siblingIndex + 1);
	self.btnList:setButtonCell(Lua_CollectionCabinetDrawBtnItem);
	self.btnList:setButtonItem(182, 80);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setRedPoint(75, 20);
	self.btnList:setData(btnInfo);
	self.btnList:setSelected(1);

	self:initShowInfo();

	self.drawMaskIcon.clickScale = false;
	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.curRewardBtn:addClickFuntion(self, self.onCurRewardClick);
	self.nextPreviewBtn:addClickFuntion(self, self.onNextPreviewClick);
	self.addBtn:addClickFuntion(self, self.onGetPahtClick);
	self.oneDrawBtn:addClickFuntion(self, self.onOneDrawClick);
	self.moreDrawBtn:addClickFuntion(self, self.onMoreDrawClick);
	self.readBtn:addClickFuntion(self, self.onReadClick);
	self.drawMaskIcon:addClickFuntion(self, self.onBgClick);
	self.skipBtn:addClickFuntion(self, self.onSkipClick);
end

function Lua_CollectionCabinetDrawPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);
		self:initShowInfo();
	end
end

function Lua_CollectionCabinetDrawPanel:initShowInfo()
	if self.adaptHeight < 0 then
		self.titleIcon:setLocation(-4, 515, 0);
		self.btnBg:setLocation(0, 427, 0);
		self.btnList:setLocation(0, 427, 0);
		self.recordBg:setLocation(0, 136, 0);
		self.recordTxt:setLocation(0, 136, 0);
		self.readBtn:setLocation(self.readBtn.posX, 136, 0);
	else
		self.titleIcon:setLocation(-4, 564, 0);
		self.btnBg:setLocation(0, 464, 0);
		self.btnList:setLocation(0, 464, 0);
		self.recordBg:setLocation(0, 190, 0);
		self.recordTxt:setLocation(0, 190, 0);
		self.readBtn:setLocation(self.readBtn.posX, 190, 0);
	end
end

function Lua_CollectionCabinetDrawPanel:setDefaultInfo(info)
	if info and info.sub_id and self.btnList then
		self.btnList:setSelected(info.sub_id);
	end
end

function Lua_CollectionCabinetDrawPanel:onBtnClick(index)
	self.selectIdx = index;
	if index == 1 then -- 低级
		self.oneDrawTimes = DataCenter.collectionCabinetUtil.oneLowDrawTimes;
		self.moreDrawTimes = DataCenter.collectionCabinetUtil.moreLowDrawTimes;
		self.oneCostList = DataCenter.collectionCabinetUtil.oneLowDrawCostList;
		self.moreCostList = DataCenter.collectionCabinetUtil.moreLowDrawCostList;
		self.moreDrawRedPoint:changeRedPoint(Lua_RedPointList.NewCollectionCabinet_Draw_LowMoreDraw);
	else -- 高级
		self.oneDrawTimes = DataCenter.collectionCabinetUtil.oneDrawTimes;
		self.moreDrawTimes = DataCenter.collectionCabinetUtil.moreDrawTimes;
		self.oneCostList = DataCenter.collectionCabinetUtil.oneDrawCostList;
		self.moreCostList = DataCenter.collectionCabinetUtil.moreDrawCostList;
		self.moreDrawRedPoint:changeRedPoint(Lua_RedPointList.NewCollectionCabinet_Draw_MoreDraw);
	end
	self.oneDrawBtn.label = LanUtil.formateStr(787028, self.oneDrawTimes);
	self.moreDrawBtn.label = LanUtil.formateStr(787028, self.moreDrawTimes);

	self.showObj_1:SetActive(index == 2);
	self.showObj_2:SetActive(index == 2);
	Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetPrizeDrawInfo(index);
	Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetDrawRecordInfo(index);
end

function Lua_CollectionCabinetDrawPanel:updateDrawPanelInfo(poolType)
	if self.selectIdx ~= poolType then
		return;
	end

	local item;
	local arr = DataCenter.collectionCabinetData:getDrawRewardInfo(poolType);
	self.dataLen = arr:getSize();
	local arrLen = self.showItemArr:getSize();
	local maxLen = self.dataLen >= arrLen and self.dataLen or arrLen;
	for i = 1, maxLen do
		item = self.showItemArr[i];
		if i > self.dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_CollectionCabinetShowItem.new(self.content);
				self.showItemArr:add(item);
			end
			item.contentName = "Lua_CollectionCabinetShowItem_" .. arr[i];
			item:setSiblingIndex(self.curRewardBtn.siblingIndex + 1);
			item:setEnable(true);
			item:setLocation(self.posList[i][1], self.posList[i][2]);
			item:setData(arr[i]);
		end
	end

	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetPeriodConfig(DataCenter.collectionCabinetData.curPeriodId);
	local list = poolType == 1 and config.low_up_role or config.up_role;
	local posX = #list > 3 and 0 or (260 - #list * 110 + 10) / 2;
	self.curPeriodList.canDrag = #list > 3;
	self.curPeriodList:setArrayData(list);
	self.curPeriodList:setLocation(posX, 0, 0);

	local startTime = os.date(LanUtil.getValue(787029), DataCenter.collectionCabinetData.curPeriodStartTime); -- %Y年%m月%d日
	local endTime = os.date(LanUtil.getValue(787029), DataCenter.collectionCabinetData.curPeriodEndTime);
	self.timeTxt.text = LanUtil.formateStr(787030, startTime, endTime);
	self.tipsTxt.text = LanUtil.formateStr(787031, DataCenter.collectionCabinetData.guaranteeTimes);
	self.leftTimesTxt.text = LanUtil.formateStr(787032, DataCenter.collectionCabinetData.diamondTimes);

	self:updateCostShow();
	self:startIdleRotation();
end

function Lua_CollectionCabinetDrawPanel:updateCostShow()
	local oneMoneyCostList = DataCenter.collectionCabinetUtil.oneMoneyCostList;
	local moreMoneyCostList = DataCenter.collectionCabinetUtil.moreMoneyCostList;
	local moneyHasNum;
	local hasNum = DataCenter.packData:getItemCountById(self.oneCostList[1]);
	if hasNum >= self.oneCostList[2] then
		self.oneDrawState = 1;
		self.oneCostTxt.text = LanUtil.formateStr(787033, spliceIconStrById(self.oneCostList[1]), hasNum, self.oneCostList[2]);
	else
		moneyHasNum = DataCenter.packData:getItemCountById(oneMoneyCostList[1]);
		if self.oneDrawTimes <= DataCenter.collectionCabinetData.diamondTimes and moneyHasNum >= oneMoneyCostList[2] then
			self.oneDrawState = 2;
			self.oneCostTxt.text = LanUtil.formateStr(787033, spliceIconStrById(oneMoneyCostList[1]), moneyHasNum, oneMoneyCostList[2]);
		else
			self.oneDrawState = 3;
			self.oneCostTxt.text = LanUtil.formateStr(787034, spliceIconStrById(self.oneCostList[1]), hasNum, self.oneCostList[2]);
		end
	end
	if hasNum >= self.moreCostList[2] then
		self.moreDrawState = 1;
		self.moreCostTxt.text = LanUtil.formateStr(787033, spliceIconStrById(self.moreCostList[1]), hasNum, self.moreCostList[2]);
	else
		moneyHasNum = DataCenter.packData:getItemCountById(moreMoneyCostList[1]);
		if self.moreDrawTimes <= DataCenter.collectionCabinetData.diamondTimes and moneyHasNum >= moreMoneyCostList[2] then
			self.moreDrawState = 2;
			self.moreCostTxt.text = LanUtil.formateStr(787033, spliceIconStrById(moreMoneyCostList[1]), moneyHasNum, moreMoneyCostList[2]);
		else
			self.moreDrawState = 3;
			self.moreCostTxt.text = LanUtil.formateStr(787034, spliceIconStrById(self.moreCostList[1]), hasNum, self.moreCostList[2]);
		end
	end

	local tvo = getConfig("item", self.oneCostList[1]);
	self.itemCostIcon:setAltas(tvo.atlas, tvo.sprite);
	self.itemNumTxt.text = hasNum;
end

-- 开始待机旋转计时器
function Lua_CollectionCabinetDrawPanel:startIdleRotation()
	if self.idleRotate ~= true then
		self.idleRotate = true;
		self.moveIdx = self.moveIdx or self.dataLen;
		self:updateIdleRotation();
		Lua_CommonUtil.addTimer("CollectionCabinet_IdleRotation", 0.5, self, self.updateIdleRotation);
	end
end

-- 更新待机旋转动画
function Lua_CollectionCabinetDrawPanel:updateIdleRotation()
	local idx = self.moveIdx == #self.posList and 0 or self.moveIdx;
	local angle = 360 / #self.posList;
	LuaUtil.setObjRot(self.rotateObj, 0, 0, -idx * angle + 45);

	self.moveIdx = self.moveIdx + 1;
	self.moveIdx = self.moveIdx > self.dataLen and 1 or self.moveIdx;
	local preMoveIdx = self.moveIdx <= 1 and self.dataLen or self.moveIdx - 1;
	self.showItemArr[preMoveIdx]:setSelected(false);
	self.showItemArr[self.moveIdx]:setSelected(true);
end

-- 结束待机旋转计时器
function Lua_CollectionCabinetDrawPanel:endIdleRotation()
	if self.idleRotate == true then
		self.idleRotate = false;
		Lua_CommonUtil.removeTimer(self, self.updateIdleRotation);
	end
end

function Lua_CollectionCabinetDrawPanel:updateDrawRewardInfo(msg)
	if msg == nil then
		return;
	end
	self.showType = msg.card_pool_type;
	self.showRewardList = msg.item_list;

	local poolId, config, sortTag, lightPoolId;
	for i = 1, #msg.award_location_list do
		poolId = msg.award_location_list[i];
		config = DataCenter.collectionCabinetUtil:getCollectionCabinetMainPoolConfig(poolId);
		if sortTag == nil or sortTag > config.sort then
			sortTag = config.sort;
			lightPoolId = poolId;
		end
	end
	self.targetIdx = DataCenter.collectionCabinetData:getShowDrawRewardIdx(msg.card_pool_type, lightPoolId);

	self.showObj_1:SetActive(false);
	self:endIdleRotation();
	self:startRewardRotation();
end

-- 开始抽奖旋转动画
function Lua_CollectionCabinetDrawPanel:startRewardRotation()
	self.maskObj:SetActive(true);
	if self.rewardRotate ~= true then
		self.rewardRotate = true;

		-- 旋转的总格子数 = 当前格子数到起点的格子数 + 旋转圈数的格子数 + 目标格子数
		self.rotationNum = self.dataLen - self.moveIdx + 2 * self.dataLen + self.targetIdx; -- 2旋转圈数
		self.rotationTime = self.rotationTime or 1; -- 轮盘旋转时间

		self.accelateNum = 6 * self.rotationTime / ((Mathf.Pow(self.rotationNum, 2) + self.rotationNum) * (2 * self.rotationNum + 1));
		self.lastNum = self.accelateNum * Mathf.Pow(self.rotationNum, 2);
		self.residue = self.residue or 0.02; -- 旋转缓冲间隔时间
		self.totalRotationNum = self.rotationNum + self.dataLen; -- 加一圈作为缓冲

		self:updateRewardRotation();
		Lua_CommonUtil.addTimer("CollectionCabinet_RewardRotation", 0.01, self, self.updateRewardRotation);
	end
end

-- 更新抽奖旋转动画
function Lua_CollectionCabinetDrawPanel:updateRewardRotation()
	self.curRotationNum = self.curRotationNum and self.curRotationNum + 1 or 1;
	if self.curRotationNum > self.totalRotationNum then
		self.curRotationNum = nil;
		self.curNum = nil;

		self:endRewardRotation();
		self:startLighting();
	else
		self:updateIdleRotation();
		if self.curRotationNum >= self.rotationNum then -- 额外缓冲
			self.curNum = self.curNum and self.curNum + 1 or 1;
			self.curSecNum = self.lastNum + self.residue * (self.curNum - 1);
		else
			self.curSecNum = self.accelateNum * Mathf.Pow(self.curRotationNum, 2); -- y = a * x ^ 2
		end
		Lua_CommonUtil.addTimer("CollectionCabinet_RewardRotation", self.curSecNum, self, self.updateRewardRotation);
	end
end

-- 结束抽奖旋转动画
function Lua_CollectionCabinetDrawPanel:endRewardRotation()
	if self.rewardRotate == true then
		self.rewardRotate = false;
		Lua_CommonUtil.removeTimer(self, self.updateRewardRotation);
	end
end

-- 发光外圈
function Lua_CollectionCabinetDrawPanel:startLighting()
	if self.lighting ~= true then
		self.lighting = true;
		self.lightCount = 7;
		self:updateLighting();
		Lua_CommonUtil.addTimer("CollectionCabinet_lighting", 0.01, self, self.updateLighting);
	end
end

-- 闪烁控制
function Lua_CollectionCabinetDrawPanel:updateLighting()
	self.lightCount = self.lightCount - 1;
	self.showItemArr[self.moveIdx]:setSelected(self.lightCount % 2 ~= 0);
	if self.lightCount == 1 then
		self:endLighting();
		self:showRewardsInfo(); -- 展示奖励
	end
end

-- 结束闪烁
function Lua_CollectionCabinetDrawPanel:endLighting()
	if self.lighting == true then
		self.lighting = false;
		Lua_CommonUtil.removeTimer(self, self.updateLighting);
	end
end

-- 显示奖励，播放广播
function Lua_CollectionCabinetDrawPanel:showRewardsInfo()
	self.showObj_1:SetActive(self.selectIdx == 2);
	self.maskObj:SetActive(false);
	if self.showRewardList then
		self:updateDrawPanelInfo(self.showType);
		local vo;
		local rewardArr = Array();
		for i = 1, #self.showRewardList do
			vo = DataCenter.packData:getRewardVo(self.showRewardList[i]);
			rewardArr:add(vo);
		end
		Lua_WindowUtil.openWin("Lua_CollectionCabinetDrawRewardWindow", Lua_WinParam.ACTION_OPEN, rewardArr);
	end
	self.showType = nil;
	self.showRewardList = nil;

	local len = self.recordBroadcastIdArr:getSize();
	while(len > 0) do
		local broadcastId = self.recordBroadcastIdArr:remove(len);
		DataCenter.chatData:playNextBroadcast(broadcastId); -- 播放广播
		len = len - 1;
	end
	self.isDelayShowRecord = false;
	self:updateDrawRecordInfo();
end

function Lua_CollectionCabinetDrawPanel:updateDrawRecordInfo(msg)
	if msg ~= nil then
		self.serverRecordMsg = msg;
	end
	if self.isDelayShowRecord then
		return;
	end

	local posY = self.adaptHeight < 0 and 136 or 190;
	if self.serverRecordMsg and self.serverRecordMsg.record_list[1] then
		local recordInfo = self.serverRecordMsg.record_list[1];
		local tvo = Lua_ToolVo.createToolVo(recordInfo.value, recordInfo.ex_value);
		self.recordTxt.text = LanUtil.formateStr(787035, recordInfo.key, tvo.colorName, tvo.count);
		self.recordTxt:resetSize();
		self.readBtn:setLocation(self.recordTxt.width / 2 + self.readBtn.width + 10, posY);
		self.readBtn:setEnable(true);
	else
		self.recordTxt.text = "";
		self.readBtn:setLocation(215, posY, 0);
		self.readBtn:setEnable(false);
	end
	self.serverRecordMsg = nil;
end

function Lua_CollectionCabinetDrawPanel:onRuleClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDrawRuleWindow", Lua_WinParam.ACTION_OPEN, self.selectIdx);
end

function Lua_CollectionCabinetDrawPanel:onCurRewardClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDrawCurRewardWindow", Lua_WinParam.ACTION_OPEN, self.selectIdx);
end

function Lua_CollectionCabinetDrawPanel:onNextPreviewClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDrawNextPrizeWindow", Lua_WinParam.ACTION_OPEN, self.selectIdx);
end

function Lua_CollectionCabinetDrawPanel:onGetPahtClick(go)
	if self.oneCostList and self.oneCostList[1] then
		DataCenter.packUtil:openPathWindow(self.oneCostList[1], false);
	end
end

function Lua_CollectionCabinetDrawPanel:onOneDrawClick(go)
	if self.checkTime and getTime() - self.checkTime < 0.5 then
		OperateAlert.showLangValue(787045);
		return;
	end
	self.checkTime = getTime();

	self.drawType = 1;
	if self.oneDrawState == 1 then
		self:onDrawFun(self.oneDrawTimes);
	elseif self.oneDrawState == 2 then
		if not DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.COLLECTIONCABINET_DRAW) then
			local oneMoneyCostList = DataCenter.collectionCabinetUtil.oneMoneyCostList;
			local tvo = Lua_ToolVo.createToolVo(oneMoneyCostList[1]);
			local tipsData = {
				owner = self,
				des = LanUtil.formateStr(787036, oneMoneyCostList[2], tvo.name, self.oneDrawTimes),
				neverTip = Lua_NeverTipDefine.COLLECTIONCABINET_DRAW,
				btnType = 1,
				sureFun = self.onSureDrawFun
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		else
			self:onDrawFun(self.oneDrawTimes);
		end
	elseif self.oneDrawState == 3 then
		DataCenter.packUtil:openPathWindow(self.oneCostList[1]);
	end
end

function Lua_CollectionCabinetDrawPanel:onMoreDrawClick(go)
	if self.checkTime and getTime() - self.checkTime < 0.5 then
		OperateAlert.showLangValue(787045);
		return;
	end
	self.checkTime = getTime();

	self.drawType = 2;
	if self.moreDrawState == 1 then
		self:onDrawFun(self.moreDrawTimes);
	elseif self.moreDrawState == 2 then
		if not DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.COLLECTIONCABINET_DRAW) then
			local moreMoneyCostList = DataCenter.collectionCabinetUtil.moreMoneyCostList;
			local tvo = Lua_ToolVo.createToolVo(moreMoneyCostList[1]);
			local tipsData = {
				owner = self,
				des = LanUtil.formateStr(787036, moreMoneyCostList[2], tvo.name, self.moreDrawTimes),
				neverTip = Lua_NeverTipDefine.COLLECTIONCABINET_DRAW,
				btnType = 1,
				sureFun = self.onSureDrawFun
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		else
			self:onDrawFun(self.moreDrawTimes);
		end
	elseif self.moreDrawState == 3 then
		DataCenter.packUtil:openPathWindow(self.oneCostList[1]);
	end
end

function Lua_CollectionCabinetDrawPanel:onSureDrawFun()
	local drawTimes = self.drawType == 1 and self.oneDrawTimes or self.moreDrawTimes;
	self:onDrawFun(drawTimes);
end

function Lua_CollectionCabinetDrawPanel:onDrawFun(drawTimes)
	local list, info;
	if self.selectIdx == 1 then -- 低级
		list = DataCenter.collectionCabinetUtil.lowDrawBroadcastList;
	else -- 高级
		list = DataCenter.collectionCabinetUtil.drawBroadcastList;
	end
	for i = 1, #list do
		info = DataCenter.collectionCabinetData:getShowDrawRewardIdx(self.selectIdx, list[i][1]);
		if info then
			self.recordBroadcastIdArr:add(list[i][2]);
			DataCenter.chatData:setDelayBroadcast(list[i][2]); -- 拦截广播
		end
	end

	self.isDelayShowRecord = true;
	self.drawType = nil;
	Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetPrizeDraw(self.selectIdx, drawTimes);
end

function Lua_CollectionCabinetDrawPanel:onReadClick(go)
	Lua_WindowUtil.openWin("Lua_CollectionCabinetDrawRecordWindow", Lua_WinParam.ACTION_OPEN, self.selectIdx);
end

function Lua_CollectionCabinetDrawPanel:onBgClick(go)
end

function Lua_CollectionCabinetDrawPanel:onSkipClick(go)
	self.curRotationNum = nil;
	self.curNum = nil;
	self.maskObj:SetActive(false);
	self:endRewardRotation();
	self:endLighting();
	self:showRewardsInfo();
end

function Lua_CollectionCabinetDrawPanel:dispose()
	if self.curPeriodList ~= nil then
		self.curPeriodList:dispose();
		self.curPeriodList = nil;
	end
	if self.moreDrawRedPoint ~= nil then
		self.moreDrawRedPoint:dispose();
		self.moreDrawRedPoint = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	self.posList = nil;
	self.drawType = nil;
	self.oneDrawTimes = nil;
	self.moreDrawTimes = nil;
	self.oneCostList = nil;
	self.moreCostList = nil;
	self:endIdleRotation();
	self:endRewardRotation();
	self:endLighting();
	self:superCall("dispose");
end









Lua_CollectionCabinetShowItem = class("Lua_CollectionCabinetShowItem", Lua_DisplayObject);
function Lua_CollectionCabinetShowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);
	self.itemIcon:setScale(0.95, 0.95);

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "collection_cabinet_atlas_2", "xui_cpg_widget_32", 0, 0, 0, 0);
	self.selectIcon:setEnable(false);
	self.selectIcon:setScale(0.95, 0.95);
end

function Lua_CollectionCabinetShowItem:setData(data)
	if data == nil then
		return;
	end

	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetMainPoolConfig(data);
	local tvo = Lua_ToolVo.createToolVo(config.show_item_list[1], config.show_item_list[2]);
	self.itemIcon:setData(tvo);
end

function Lua_CollectionCabinetShowItem:setSelected(bShow)
	self.selectIcon:setEnable(bShow);
end

function Lua_CollectionCabinetShowItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	self:superCall("dispose");
end











Lua_CollectionCabinetDrawRewardItem = class("Lua_CollectionCabinetDrawRewardItem", Lua_ItemIconCell);
function Lua_CollectionCabinetDrawRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetDrawRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.8, 0.8);
end

function Lua_CollectionCabinetDrawRewardItem:setData(data)
	if data == nil then
		return ;
	end

	self.data = Lua_ToolVo.createToolVo(data[1][1], data[1][2]);
	self.itemIcon:setData(self.data);
end

function Lua_CollectionCabinetDrawRewardItem:dispose()
	self:superCall("dispose");
end










Lua_CollectionCabinetDrawBtnItem = class("Lua_CollectionCabinetDrawBtnItem", Lua_ButtonCell);
function Lua_CollectionCabinetDrawBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetDrawBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 198, 80);
	self.btnBg.clickScale = false;
	self.btnBg:addClickFuntion(self, self.onPressClick);
end

function Lua_CollectionCabinetDrawBtnItem:setData(data)
	self:superCall("setData", data);
end

function Lua_CollectionCabinetDrawBtnItem:setCanClick(bCan)
	if bCan then
		self.btnBg.mouseEnable = true;
		self.btnBg:addClickFuntion(self, self.onPressClick);
	else
		self.btnBg.mouseEnable = false;
		self.btnBg:removeClickFuntion(self, self.onPressClick);
	end
end

function Lua_CollectionCabinetDrawBtnItem:setSelected(index)
	self:superCall("setSelected", index)
	if index == self.index then
		if self.data.drawType == 1 then
			self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_cbg_tab_001_s");
		else
			self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_cbg_tab_002_s");
		end
	else
		if self.data.drawType == 1 then
			self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_cbg_tab_001");
		else
			self.btnBg:setAltas("collection_cabinet_atlas_2", "xui_cbg_tab_002");
		end
	end
end

function Lua_CollectionCabinetDrawBtnItem:dispose()
	if self.btnBg ~= nil then
		self.btnBg:dispose();
		self.btnBg = nil;
	end
	self:superCall("dispose");
end