-- 藏品柜-抽奖记录信息界面
Lua_CollectionCabinetDrawRecordWindow = class("Lua_CollectionCabinetDrawRecordWindow", Lua_Window);
function Lua_CollectionCabinetDrawRecordWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetDrawRecordWindow";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.01;
end

function Lua_CollectionCabinetDrawRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tips_001", 0, -1, 504, 607);

	self.recordList = Lua_DragList.new(self.content, 404, 520, Lua_AxisDefine.Vertical);
	self.recordList:setListCell(Lua_CollectionCabinetDrawRecordItem, 404, 24, 1);
	self.recordList:setCellSpacing(0, 6);
	self.recordList:setLocation(0, -1, 0);

	self:addLuaEvent("UPDATE_NEW_COLLECTION_CABINET_DRAWRECORD_INFO", self, self.updateDrawRecordInfo);
end

function Lua_CollectionCabinetDrawRecordWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_CollectionCabinetProxy"):sCollectionCabinetDrawRecordInfo(param);
end

function Lua_CollectionCabinetDrawRecordWindow:updateDrawRecordInfo(msg)
	self.recordList:setArrayData(msg.record_list);
end

function Lua_CollectionCabinetDrawRecordWindow:dispose()
	if self.recordBg ~= nil then
		self.recordBg:dispose();
		self.recordBg = nil;
	end
	if self.recordList ~= nil then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end











Lua_CollectionCabinetDrawRecordItem = class("Lua_CollectionCabinetDrawRecordItem", Lua_ListCell);
function Lua_CollectionCabinetDrawRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetDrawRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.recordTxt = UICreate.createLabel(self.content, nil, 0, 0, 404, 35, 22);
	self.recordTxt.alignmentValue = 3;
end

function Lua_CollectionCabinetDrawRecordItem:setData(data)
	if data == nil then
		return ;
	end
	local tvo = Lua_ToolVo.createToolVo(data.value, data.ex_value);
	self.recordTxt.text = LanUtil.formateStr(787035, data.key, tvo.colorName, tvo.count);
end

function Lua_CollectionCabinetDrawRecordItem:dispose()
	if self.recordTxt ~= nil then
		self.recordTxt:dispose();
		self.recordTxt = nil;
	end
	self:superCall("dispose");
end