-- 藏品柜-抽奖规则界面
Lua_CollectionCabinetDrawRuleWindow = class("Lua_CollectionCabinetDrawRuleWindow", Lua_Window);
function Lua_CollectionCabinetDrawRuleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionCabinetDrawRuleWindow";
	self.skinName = "CollectionCabinetDrawRuleWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -570;
end

function Lua_CollectionCabinetDrawRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.probabilityObj, 500, 325, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_CollectionCabinetDrawRuleItem, 500, 30, 1);
	self.rewardList:setLocation(0, -80, 0);
	self.rewardList:setRectPivot(1);
end

function Lua_CollectionCabinetDrawRuleWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.collectionCabinetUtil:getCollectionCabinetDrawRuleInfoByType(param);
	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetRuleConfig(arr[1]);
	self.ruleTxt.text = config.des;
	self.ruleTxt:resetSize();

	local posY = self.ruleTxt.posY - self.ruleTxt.height - 40;
	LuaUtil.setObjPos(self.probabilityObj, 0, posY, 0);

	local rectH = posY - 60 + 400; -- 400是最低的PosY
	self.rewardList:setContentRect(500, rectH);
	self.rewardList:setArrayData(arr, 2);
	self.rewardList.canDrag = arr:getSize() * 30 > rectH;
end

function Lua_CollectionCabinetDrawRuleWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_CollectionCabinetDrawRuleItem = class("Lua_CollectionCabinetDrawRuleItem", Lua_ListCell);
function Lua_CollectionCabinetDrawRuleItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionCabinetDrawRuleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameTxt = UICreate.createLabel(self.content, "", -75, 0, 350, 30, 20);
	self.nameTxt.alignmentValue = 3;
	self.nameTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.nameTxt.lineSpacing = 1.3;

	self.probabilityTxt = UICreate.createLabel(self.content, "", 172, 0, 140, 30, 20);
	self.probabilityTxt.alignmentValue = 4;
	self.probabilityTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.probabilityTxt.lineSpacing = 1.3;
end

function Lua_CollectionCabinetDrawRuleItem:setData(data)
	if data == nil then
		return;
	end

	local config = DataCenter.collectionCabinetUtil:getCollectionCabinetRuleConfig(data);
	self.nameTxt.text = config.des;
	self.probabilityTxt.text = config.probability;
end

function Lua_CollectionCabinetDrawRuleItem:dispose()
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	if self.probabilityTxt ~= nil then
		self.probabilityTxt:dispose();
		self.probabilityTxt = nil;
	end
	self:superCall("dispose");
end